C
C PC version for Win95 adapted by A. Le Bail, June 1996.
C                              from:
C
C VAX SHELX-76 400 ATOMS, UPDATED BY  D. RABINOVICH AND K. REICH
C DEPARTMENT OF STRUCTURAL CHEMISTRY, WEIZMANN INST. OF SCIENCE,
C REHOVOT, ISRAEL, 1979    (AND SUBSEQUENTLY MODIFIED BY GMS).
C
C SEE COMMENT AT START OF SUBROUTINE XERR FOR ADAPTING Fo/Fc TABLE
C OUTPUT TO DIFFERENT PAGE SIZES (E.G. FOR LASER PRINTERS)
C
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,A(146000)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      CHARACTER*40 LINE,temp
      logical qex
C
C LM IS DIMENSION OF A, AND MUST BE AT LEAST 17000.
C MBF IS DIMENSION OF F AND HENCE INTERNAL BUFFER SIZE FOR UNITS LA
C LC, AND LF.   MBF MUST BE GREATER THAN 83, AND DIVISIBLE BY 6.
C IF MBF IS CHANGED, THE DIMENSION OF F IN ALL SUBROUTINES (AND E
C IN SMERG) MUST BE CHANGED ACCORDINGLY.
C
      LM=146000
      MBF=84
C
C LOGICAL UNIT NUMBERS FOR INSTRUCTIONS, HKLF INPUT, LINEPRINTER, PUNCH,
C THREE SCRATCH FILES AND DATA FILE FOLLOW.  ALL SHOULD BE DIFFERENT.
C
      LR=15
      LH=11
      LI=16
      LP=17
      LA=12
      LINE=' '
      PRINT 100
100   FORMAT('  Entry file (without extension) ??',$)
      READ 101,LINE
101   FORMAT(A40)
      N=41
  1   N=N-1
      IF(LINE(N:N).NE.' ')GOTO 4
      IF(N.GT.1)GOTO 1
  2   WRITE(*,3)
      STOP
  3   FORMAT(/' ** CANNOT OPEN FILE(S) - CHECK COMMAND LINE **'/)
  4   M=N
  5   M=M-1
      IF(M.LT.1)GOTO 2
      OPEN(UNIT=LR,FILE=LINE(1:N)//'.INS',STATUS='OLD',ERR=2)
      temp=LINE(1:N)//'.RES'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 200
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(LP,temp)
200   OPEN(UNIT=LP,FILE=LINE(1:N)//'.RES',STATUS='NEW',ERR=2)
      temp=LINE(1:N)//'.LIS'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 201
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(LI,temp)
201   OPEN(UNIT=LI,FILE=LINE(1:N)//'.LIS',STATUS='NEW',ERR=2)
      temp=LINE(1:N)//'.NEW'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 202
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(LA,temp)
202   OPEN(UNIT=LA,FILE=LINE(1:N)//'.NEW',STATUS='NEW',ERR=2)
      OPEN(UNIT=LH,FILE=LINE(1:N)//'.HKL',STATUS='OLD',ERR=6)
C
C LU=1 IF INTEGER WORD LENGTH IS HALF REAL WORD LENGTH (OR LESS),
C OTHERWISE LU=0.  N.B. INTEGERS MUST BE AT LEAST 24 BITS.  IF LU=1,
C THE MINIMUM VALUE OF LM IS REDUCED TO 10700.
C
  6   LU=0
C
C HA AND HD ARE NUMBER OF CHARACTERS PER INCH ACROSS AND DOWN
C PRINTER PAGE RESPECTIVELY.
C
      HA=10.
      HD=8.
C
      LV=MBF-5
      CALL INIT
      CALL XDRED
      CALL SMERG
      CALL ATFIX
      CALL XREF
      CALL ABOND
      CALL XMAP
      CALL XERR
      STOP
      END
C
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close(unit,status='delete')
      return
      end
C
      SUBROUTINE HKL(Q,X,Y,Z)
      Z=AINT(0.0001*Q+SIGN(0.5,Q))
      X=(AINT(Q+SIGN(0.5,Q))-10000.*Z)*0.01
      Y=AINT(X+SIGN(0.5,X+0.1))
      X=AINT(101.*(X-Y))
      RETURN
      END
C
      SUBROUTINE INIT
      DIMENSION IH(71),E(228),EW(36)
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,
     *IT(40),H(100),F(84),C(4380),JN(400),IN(1620),IR(76),IG(48),
     *B(645),CF(100),A(200),G(52),IS(76),IP(20),D(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      DATA IH(1)/1H0/,IH(2)/1H1/,IH(3)/1H2/,IH(4)/1H3/,IH(5)/1H4/
      DATA IH(6)/1H5/,IH(7)/1H6/,IH(8)/1H7/,IH(9)/1H8/,IH(10)/1H9/
      DATA IH(11)/1H./,IH(12)/1H-/,IH(13)/1H+/,IH(14)/1HX/,IH(15)/1HY/
      DATA IH(16)/1HZ/,IH(17)/1H,/,IH(18)/1H=/,IH(19)/4HCELL/
      DATA IH(20)/4HEND /,IH(21)/4HHKLF/,IH(22)/4HLATT/,IH(23)/4HBLOC/
      DATA IH(24)/4HSFAC/,IH(25)/4HUNIT/,IH(26)/4HAXIS/,IH(27)/4HILSF/
      DATA IH(28)/4HGRID/,IH(29)/4HANIS/,IH(30)/4HXXXX/,IH(31)/4HAFIX/
      DATA IH(32)/4HFVAR/,IH(33)/4HBOND/,IH(34)/4HWGHT/,IH(35)/4HABSC/
      DATA IH(36)/4HFMAP/,IH(37)/4HL.S./,IH(38)/4HXXXX/,IH(39)/4HXXXX/
      DATA IH(40)/4HDFIX/,IH(41)/4HUNDO/,IH(42)/4HLIST/,IH(43)/4HOMIT/
      DATA IH(44)/4HPLAN/,IH(45)/4HFACE/,IH(46)/4HMERG/,IH(47)/4HAFLS/
C
C GAUSSIAN COEFFICIENTS
C
      DATA E(1)/.5773503/,E(2)/.8611363/,E(3)/.3399810/,E(4)/.9324695/
      DATA E(5)/.6612094/,E(6)/.2386192/,E(7)/.9602899/,E(8)/.7966665/
      DATA E(9)/.5255324/,E(10)/.1834346/,E(11)/.9739065/
      DATA E(12)/.8650634/,E(13)/.6794096/,E(14)/.4333954/
      DATA E(15)/.1488743/,E(16)/.9815606/,E(17)/.9041173/
      DATA E(18)/.7699027/,E(19)/.5873180/,E(20)/.3678315/
      DATA E(21)/.1252334/,E(22)/.9862838/,E(23)/.9284349/
      DATA E(24)/.8272013/,E(25)/.6872929/,E(26)/.5152486/
      DATA E(27)/.3191124/,E(28)/.1080549/,E(29)/.9894009/
      DATA E(30)/.9445750/,E(31)/.8656312/,E(32)/.7554044/
      DATA E(33)/.6178762/,E(34)/.4580168/,E(35)/.2816036/
      DATA E(36)/.0950125/,EW(1)/1./,EW(2)/.3478548/,EW(3)/.6521452/
      DATA EW(4)/.1713245/,EW(5)/.3607616/,EW(6)/.4679139/
      DATA EW(7)/.1012285/,EW(8)/.2223810/,EW(9)/.3137066/
      DATA EW(10)/.3626838/,EW(11)/.0666713/,EW(12)/.1494513/
      DATA EW(13)/.2190864/,EW(14)/.2692667/,EW(15)/.2955242/
      DATA EW(16)/.0471753/,EW(17)/.1069393/,EW(18)/.1600783/
      DATA EW(19)/.2031674/,EW(20)/.2334925/,EW(21)/.2491470/
      DATA EW(22)/.0351195/,EW(23)/.0801581/,EW(24)/.1215186/
      DATA EW(25)/.1572032/,EW(26)/.1855384/,EW(27)/.2051985/
      DATA EW(28)/.2152639/,EW(29)/.0271525/,EW(30)/.0622535/
      DATA EW(31)/.0951585/,EW(32)/.1246290/,EW(33)/.1495960/
      DATA EW(34)/.1691565/,EW(35)/.1826034/,EW(36)/.1894506/
C
C SFAC C  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(48)/1HC/,IH(49)/1H /,E(37)/1.93/,E(38)/12.72/,E(39)/1.878/
      DATA E(40)/28.6/,E(41)/1.574/,E(42)/.5965/,E(43)/.371/,E(44)/65./
      DATA E(45)/.247/,E(46)/.002/,E(47)/.002/,E(48)/5.98/,E(49)/.75/
      DATA E(50)/.017/,E(51)/.009/,E(52)/77.8/
C
C SFAC N  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(50)/1HN/,IH(51)/1H /,E(53)/12.791/,E(54)/.02064/
      DATA E(55)/3.287/,E(56)/10.7/,E(57)/1.767/,E(58)/30.8/,E(59)/.547/
      DATA E(60)/1.48/,E(61)/-11.392/,E(62)/.004/,E(63)/.003/,E(64)/14./
      DATA E(65)/.7/,E(66)/.029/,E(67)/.018/,E(68)/156./
C
C SFAC O  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(52)/1HO/,IH(53)/1H /,E(69)/2.957/,E(70)/13.9/
      DATA E(71)/2.452/,E(72)/5.92/,E(73)/1.505/,E(74)/.3454/
      DATA E(75)/.782/,E(76)/34.1/,E(77)/.304/,E(78)/.008/,E(79)/.006/
      DATA E(80)/23.9/,E(81)/.67/,E(82)/.047/,E(83)/.032/,E(84)/279./
C
C SFAC F  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(54)/1HF/,IH(55)/1H /,E(85)/3.304/,E(86)/11.265/
      DATA E(87)/3.018/,E(88)/4.665/,E(89)/1.358/,E(90)/.3376/
      DATA E(91)/.836/,E(92)/28./,E(93)/.484/,E(94)/.014/,E(95)/.01/
      DATA E(96)/41./,E(97)/.65/,E(98)/.069/,E(99)/.053/,E(100)/464./
C
C SFAC SI ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(56)/1HS/,IH(57)/1HI/,E(101)/5.794/,E(102)/2.571/
      DATA E(103)/3.224/,E(104)/34.18/,E(105)/2.428/,E(106)/.869/
      DATA E(107)/1.322/,E(108)/85.3/,E(109)/1.232/,E(110)/.072/
      DATA E(111)/.071/,E(112)/284./,E(113)/1.05/,E(114)/.244/
      DATA E(115)/.33/,E(116)/2868./
C
C SFAC P  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(58)/1HP/,IH(59)/1H /,E(117)/6.921/,E(118)/1.838/
      DATA E(119)/4.144/,E(120)/27./,E(121)/2.017/,E(122)/.2132/
      DATA E(123)/1.539/,E(124)/67.1/,E(125)/.379/,E(126)/.09/
      DATA E(127)/.095/,E(128)/375./,E(129)/1.05/,E(130)/.283/
      DATA E(131)/.434/,E(132)/3764./
C
C SFAC S  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(60)/1HS/,IH(61)/1H /,E(133)/7.187/,E(134)/1.433/
      DATA E(135)/5.887/,E(136)/.02865/,E(137)/5.159/,E(138)/22.1/
      DATA E(139)/1.644/,E(140)/55.5/,E(141)/-3.877/,E(142)/.11/
      DATA E(143)/.124/,E(144)/495./,E(145)/1.1/,E(146)/.319/
      DATA E(147)/.557/,E(148)/4834./
C
C SFAC CL ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(62)/1HC/,IH(63)/1HL/,E(149)/9.84/,E(150)/-0.00053/
      DATA E(151)/7.532/,E(152)/1.111/,E(153)/6.071/,E(154)/18.085/
      DATA E(155)/1.871/,E(156)/45.4/,E(157)/-8.314/,E(158)/.132/
      DATA E(159)/.159/,E(160)/636./,E(161)/1.1/,E(162)/.348/
      DATA E(163)/.702/,E(164)/6099./
C
C SFAC B  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891
C
      DATA IH(64)/1HB/,IH(65)/1H /,E(165)/2.0397/,E(166)/23.09/
      DATA E(167)/1.415/,E(168)/.9784/,E(169)/1.1167/,E(170)/59.9/
      DATA E(171)/.7327/,E(172)/.0854/,E(173)/-0.3041/,E(174)/0./
      DATA E(175)/.001/,E(176)/3.593/,E(177)/.70/,E(178)/.008/
      DATA E(179)/.004/,E(180)/34.13/
C
C SFAC BR  ACTA CRYST. A24 (1968) 390 AND J.CHEM.PHYS. 53 (1970)1891
C
      DATA IH(66)/1HB/,IH(67)/1HR/,E(181)/17.18/,E(182)/2.172/
      DATA E(183)/5.238/,E(184)/16.58/,E(185)/5.638/,E(186)/.2609/
      DATA E(187)/3.988/,E(188)/41.4/,E(189)/2.956/,E(190)/-.374/
      DATA E(191)/2.456/,E(192)/9818./,E(193)/1.2/,E(194)/-.767/
      DATA E(195)/1.283/,E(196)/11145./
C
C SFAC SN  ACTA CRYST. A24 (1968) 390 AND J.CHEM.PHYS. 53 (1970)1891
C
      DATA IH(68)/1HS/,IH(69)/1HN/,E(197)/19.19/,E(198)/5.83/
      DATA E(199)/19.1/,E(200)/.5031/,E(201)/4.46/,E(202)/26.9/
      DATA E(203)/2.47/,E(204)/84./,E(205)/4.78/,E(206)/-.873/
      DATA E(207)/1.424/,E(208)/5695./,E(209)/1.45/,E(210)/-0.194/
      DATA E(211)/5.459/,E(212)/47416./
C
C SFAC H  D.T. CROMER, PERSONAL COMMUNICATION BASED ON BONDED SPHERICAL
C         ATOM MODEL, R.F. STEWART ET AL., J.CHEM.PHYS. 42 (1965) 3175
C
      DATA IH(70)/1HH/,IH(71)/1H /,E(213)/.493/,E(214)/10.511/
      DATA E(215)/.323/,E(216)/26.126/,E(217)/.1402/,E(218)/3.1424/
      DATA E(219)/.0408/,E(220)/57.8/,E(221)/.003/,E(222)/0./
      DATA E(223)/0./,E(224)/.06/,E(225)/.33/,E(226)/0./
      DATA E(227)/0./,E(228)/.07/
C
      WRITE(LI,1)
1     FORMAT(1H1)
      DO 2 I=1,40
2     IT(I)=IH(49)
      DO 3 I=1,47
3     IG(I)=IH(I)
      IG(48)=IH(49)
      DO 4 I=48,71
4     IN(I+1549)=IH(I)
      DO 5 I=37,228
5     C(I+4152)=E(I)
      BN=0.
      KZ=0
      ME=0
      MF=1
      KF=-3
C
C INTEGRATION COEFFICIENTS
C
      M=1
      K=1
      DO 6 I=1,8
      L=M
      M=M+I+I
      DO 6 J=1,I
      N=M-J
      B(L)=E(K)*0.5+0.5
      B(L+72)=EW(K)*0.5
      B(N)=1.-B(L)
      B(N+72)=B(L+72)
      K=K+1
6     L=L+1
      DO 7 I=145,645
7     B(I)=EXP(FLOAT(145-I)*0.03125)
C
C SET UP IN AND C
C
      DO 8 I=1,1596
8     IN(I)=0
      DO 9 I=1,4188
9     C(I)=0.
      C(26)=-99.
      C(31)=1.E5
      DO 10 I=33,35
      C(I)=-2.
10    C(I+3)=2.
      C(39)=-999.
      C(40)=99.
      C(43)=.25
      C(44)=.95
      C(46)=1.
      C(48)=-999.
      C(50)=1.08
      C(51)=1.42
      C(52)=1.395
      C(59)=1.
      C(60)=1.E9
      C(61)=1.
      C(65)=1.
      C(69)=1.
      IN(1)=61
      IN(2)=-99
      IN(6)=17
      IN(9)=-9999
      IN(13)=-999
      IN(16)=28
      IN(17)=100
      IN(18)=1
      DO 100 I=1,10000
      DO 100 J=1,84
      EE(I,J)=0.
      FC(I,J)=0.
100   FF(I,J)=0.
      DO 115 I=1,40
115   IIT(I)=0
      DO 116 I=1,400
116   JJN(I)=0
      DO 117 I=1,1620
117   IIN(I)=0
      DO 118 I=1,4380
118   CC(I)=0.
      ILF=0
      ILA=0
      ILC=0
      RETURN
      END
C
      SUBROUTINE XDRED
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,
     *IT(40),H(100),F(84),C(4380),JN(400),IN(1620),IR(76),IH(48),
     *B(645),CF(100),A(200),E(52),IS(76),IP(20),D(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      DATA JT/4HTITL/,JY/4HSYMM/,JZ/4H    /
1     FORMAT(A4,76A1)
2     FORMAT(1H ,A4,76A1)
      MP=0
      JS=0
      JB=0
      L=73
      NY=0
      NX=1
      NQ=0
      NF=0
C
C READ IN FREE FORMAT
C
3     READ(LR,1)I,IR
      WRITE(LI,2)I,IR
      IF(I.EQ.JZ)GOTO 3
      IF(I.EQ.JT)GOTO 127
      N=0
      NK=47
      NER=-9
      IF(4380-L)23,4,4
4     IF(I.EQ.IH(NK)) GOTO 5
      NK=NK-1
      IF(18-NK)4,5,5
5     NK=NK-17
      NER=-1
      ASSIGN 16 TO JJ
      IF(I.NE.JY)GOTO 24
      NJ=L-5
      L=L+9
6     W=1.
7     V=0.
      NB=0
      Y=1.
      U=10.
      Z=1.
      GOTO 10
8     Z=Y*Z
      V=U*ABS(V)+Z*X
      NB=1
      IF(V)9,10,9
9     V=SIGN(V,W)
      W=V
10    N=N+1
      K=10
      IF(76-N)15,11,11
11    X=0.
      DO 12 M=1,10
      IF(IR(N).EQ.IH(M)) GOTO 8
12    X=X+1.
      GOTO 14
13    IF(IR(N).EQ.IH(K+9)) GOTO 15
14    K=K-1
      IF(K-2)15,13,13
15    GOTO JJ,(16,26)
16    GOTO(10,17,31,31,18,18,18,19,21,19),K
17    U=1.
      Y=0.1
      GOTO 10
18    K=K+NJ
      C(K)=W
      GOTO 6
19    C(L)=C(L)+V
      L=L+1
      NJ=NJ+3
      IF(L-NJ-9)20,6,6
20    IN(1)=IN(1)+12
      IF(L-12-IN(1))22,3,22
21    READ(LR,1)M,IR
      WRITE(LI,2)M,IR
      N=0
      IF(JZ.EQ.M)GOTO 6
22    IN(1)=I
23    IN(20)=NER
      GOTO 147
24    DO 25 J=1,200
25    A(J)=0.
      NA=0
      ASSIGN 26 TO JJ
      GOTO 6
26    IF(K-2)27,17,27
27    NA=NA+NB
      IF(200-NA)22,28,28
28    IF(-NA)29,30,30
29    A(NA)=V+A(NA)
30    IF(K-9)32,21,34
31    C(L)=V
32    IF(K-3)6,33,6
33    W=-1.
      GOTO 7
34    GOTO(83,35,133,132,40,122,41,60,125,77,125,67,125,102,83,125,
     *118,68,120,114,64,124,103,105,119,130,129,74,72,114),NK
C
C UNITCELL
C
35    IF(7-NA)22,36,22
36    DO 37 J=1,7
      IF(0.01-A(J))37,22,22
37    C(J)=A(J)
      U=2.*A(2)*A(3)*A(4)
      DO 38 J=2,4
      C(J+9)=U*COS(.0174533*A(J+3))/A(J)
      A(J+9)=C(J+9)*C(J+9)
38    C(J+6)=A(J)*A(J)
      V=U*U
      U=V-C(8)*A(11)-C(9)*A(12)-C(10)*A(13)+C(11)*C(12)*C(13)
      C(32)=0.5*SQRT(U)
      U=39.4784/U
      DO 39 J=8,10
      C(J+6)=0.5*U*((V/C(J))-A(J+3))
39    C(J+9)=-2.*U*C(J)*C(J+3)
      C(17)=C(17)+U*C(12)*C(13)
      C(18)=C(18)+U*C(11)*C(13)
      C(19)=C(19)+U*C(11)*C(12)
      C(20)=SQRT(C(15)*C(16))*2.
      C(21)=SQRT(C(14)*C(16))*2.
      C(22)=SQRT(C(14)*C(15))*2.
      UT=78.95684/(C(1)*C(1))
      GOTO 3
C
C LATT
C
40    C(23)=0.5-SIGN(0.5,A(1)+0.01)
      IN(18)=INT(ABS(A(1)))
      IF(1-NA)22,3,3
C
C SFAC
C
41    IF(-IN(2))42,43,43
42    IF(IN(2)+103-L)22,43,22
43    IN(2)=L
      IF(-IN(3))22,44,44
44    NJ=77
      IF(NA)45,45,51
45    NJ=0
46    NJ=NJ+1
      IF(75-NJ)3,47,47
47    DO 48 J=1597,1619,2
      IF(IN(J).NE.IR(NJ))GOTO 48
      IF(IN(J+1).EQ.IR(NJ+1))GOTO 49
48    CONTINUE
      IF(IR(NJ).EQ.IH(48))GOTO 46
      NER=-13
      GOTO 23
49    NJ=NJ+1
      IN(2)=L
      J=(8*J)-8587
      K=(INT(C(1))*4)+J
      NA=13
      DO 50 M=1,13
      A(M)=C(J)
50    J=J+1
      A(10)=C(K+9)
      A(11)=C(K+10)
      A(12)=C(K+11)
51    NF=NF+1
      C(L)=A(13)
      L=L+1
      C(L)=A(11)
      W=0.
      IF(C(1)-0.01)58,52,52
52    Z=0.004/(C(1)*C(1))
      DO 56 N=1,51
      X=0.
      Y=0.
      DO 55 K=1,6
      M=L+K
      C(M)=A(9)+A(10)
      DO 54 J=1,7,2
      V=-A(J+1)*(W+X)
      IF(V+15.)54,53,53
53    C(M)=C(M)+A(J)*EXP(V)
54    CONTINUE
      X=X+Z
55    Y=Y+C(M)
      C(L+2)=1.25*Y-3.75*(C(L+1)+C(L+6))
      L=L+2
56    W=W+5.*Z
      H(NF)=C(L-101)-A(10)
      H(NF+50)=A(12)
      IF(NA-13)22,46,46
57    I=IH(25)
      GOTO 59
58    I=IH(19)
59    NER=-10
      GOTO 22
C
C UNIT
C
60    I=IH(24)
      IF(NA.NE.NF)GOTO 59
      X=0.
      C(53)=0.
      DO 61 K=1,NA
      C(53)=C(53)+H(K+50)*A(K)/C(32)
61    X=X+H(K)*A(K)
      DO 62 J=1,51
      E(J)=0.
      F(J)=0.
      M=IN(1)+J+J+12
      DO 62 K=1,NF
      Y=C(M)*C(M)*A(K)
      E(J)=E(J)+Y
      F(J)=F(J)+Y*C(M)
62    M=M+103
      IF(F(14).LT.0.001)GOTO 22
      C(45)=2.*F(14)/(E(14)*SQRT(E(14)))
      C(58)=E(1)
63    FORMAT(/4H V =,F8.2,12H    F(000) =,F8.2,8H    MU =,F8.2/)
      WRITE(LI,63)C(32),X,C(53)
      IN(3)=L-6
      GOTO 3
C
C PHIX
C
64    IF(IN(3).NE.L-6)GOTO 22
      IN(3)=L
      U=0.
      M=IN(1)
      DO 65 J=61,M,12
65    U=AMAX1(U,ABS(A(1)*C(J)+A(2)*C(J+3)+A(3)*C(J+6)+100.*(A(1)*C(J+1)+
     *A(2)*C(J+4)+A(3)*C(J+7)+100.*(A(1)*C(J+2)+A(2)*C(J+5)+A(3)*C(J+8)
     *))))
      C(L)=U
      MP=L
      L=L+1
      DO 66 J=4,8
      C(L)=A(J)
66    L=L+1
      IF(7-NA)22,3,3
C
C ANIS
C
67    NY=-INT(A(1))
      IF(NA-1)22,3,22
C
C ABSC
C
68    C(26)=5.
      C(30)=1.
      KF=-3
      IF(NA-1)71,70,69
69    C(53)=A(2)
70    C(26)=2.5/AMAX1(ABS(A(1)),0.01)
      C(30)=SIGN(1.,A(1)+0.0001)
71    IF(2-NA)22,3,3
C
C MERG
C
72    IF(NA.LT.1)GOTO 22
      DO 73 I=1,NA
73    C(I+53)=A(I)
      IF(4-NA)22,3,3
C
C FACE
C
74    IF(A(4).LT.0.00001)GOTO 22
      IF(KF.GT.96)GOTO 22
      A(4)=0.1*A(4)
      X=C(14)*A(1)*A(1)+C(15)*A(2)*A(2)+C(16)*A(3)*A(3)+
     *C(17)*A(2)*A(3)+C(18)*A(1)*A(3)+C(19)*A(1)*A(2)
      IF(0.0001.GT.X)GOTO 22
      X=SQRT(19.73921/X)
      DO 75 I=1,3
75    A(I)=A(I)*X
      DO 76 I=1,4
      CF(KF+4)=A(I)
76    KF=KF+1
      IF(NA-4)22,3,22
C
C ILSF
C
77    N=4
      J=1
      IF(-IN(4))78,79,79
78    IF(IN(4)+1-L)22,81,22
79    IN(4)=L
      IN(12)=A(1)
      C(L)=1.
      J=1
80    L=L+1
      J=J+1
81    IF(NA-J)3,82,82
82    C(L)=A(J)
      IN(N)=L
      GOTO 80
C
C FVAR ETC
C
83    N=5
      J=1
      IF(-IN(4))85,84,84
84    IN(4)=L
      C(L)=1.
      L=L+1
85    IF(-IN(5))88,86,86
86    C(L)=1.
      C(L+1)=1.
      IN(5)=L+1
      L=L+2
      IF(NK-11)89,87,87
87    C(L-2)=A(1)
      J=2
88    IF(NK-11)89,81,81
C
C ATOMS
C
89    IF(IN(7))90,90,22
90    IN(6)=IN(6)+4
      K=IN(6)
      IF(1620-K)101,91,91
91    NER=-14
      IF(NQ.LT.0)GOTO 22
      NER=-1
      IN(K+1)=NX+NQ
      NQ=A(1)
      IF(IN(2)-(103*NQ)-IN(1)+91)22,92,92
92    IN(K+2)=NQ+NQ+10
      NQ=0
      JS=JS+1
      JN(JS)=I
      IN(K+3)=JB
      IF(NA-4)22,93,94
93    A(5)=11.
      A(6)=0.05
      NA=6
94    DO 95 J=2,NA
      C(L)=A(J)
95    L=L+1
      IN(K)=10
      IF(NA-6)22,97,96
96    IF(NA-11)22,3,22
97    IF(NY)99,98,98
98    IN(K)=5
      GOTO 3
99    C(L)=A(6)
      C(L+1)=A(6)
      L=L+2
      DO 100 J=17,19
      C(L)=A(6)-AMOD(A(6),10.)*(1.-C(J)/C(J+3))
100   L=L+1
      NY=NY+1
      GOTO 3
101   I=400
      NER=-3
      GOTO 22
C
C AFIX
C
102   NQ=MAX0(0,MOD(INT(A(1)),10)-5)
      NX=INT(A(1)+1.1)-NQ
      IF(1-NA)22,3,3
C
C DFIX
C
103   IF(IN(7).LT.1)IN(7)=L
      IF(NA.LT.4)GOTO 22
      DO 104 J=3,NA,2
      U=A(J)*4.+17.1
      V=A(J+1)*4.+17.1
      C(L)=A(1)
      C(L+1)=AMAX1(A(2),0.0001)
      C(L+2)=U
      C(L+3)=V
104   L=L+4
      C(L)=0.
      IF(MOD(NA,2))22,3,22
C
C UNDO
C
105   NA=MAX0(NA,1)
      DO 113 M=1,NA
      N=A(M)
      X=0.
      IF(N)106,113,107
106   X=1.
107   K=17
      N=N+IN(4)+1
      P=AMOD(C(N)+2.,10.)-2.5
      J=IN(5)
108   K=K+4
      IF(IN(6)-K)113,109,109
109   DO 110 NI=1,3
      J=J+1
110   C(J)=20.*AINT(0.1*C(J)+SIGN(0.5,C(J)+1.E-6))*X+C(J)*(1.-2.*X)
      J=J-3
      NJ=IN(K)
      DO 112 NI=1,NJ
      J=J+1
      IF(5.-ABS(ABS(C(J))-10.*A(M)))112,111,111
111   Q=SIGN(0.5,C(J)+5.)
      R=AMOD(C(J)+5.,10.)-10.*Q
      C(J)=R*(Q+P)
112   CONTINUE
      GOTO 108
113   CONTINUE
      GOTO 3
C
C L.S.
C
114   IF(NA-2)117,116,115
115   C(47)=A(3)
116   C(46)=A(2)
117   IN(13)=SIGN(A(1),FLOAT(NK-25))
      IF(3-NA)22,3,3
C
C WGHT
C
118   C(60)=A(1)
      IN(19)=A(2)
      IN(8)=A(3)
      IF(3-NA)22,3,3
C
C LIST
C
119   IN(10)=A(1)
      IN(11)=A(2)
      IF(2-NA)22,3,3
C
C FMAP
C
120   K=MIN0(4,MAX0(NA,1))
      C(24)=A(5)
      DO 121 J=1,K
121   IN(J+13)=A(J)
      IF(5-NA)22,3,3
C
C BLOC
C
122   JB=1
      IF(NX.EQ.3)NQ=-1
      IF(NA.EQ.0)GOTO 3
      DO 123 J=1,NA
      K=A(J)
      IF(MIN0(K,14-K).LT.1)GOTO 22
123   JB=JB+2**K
      GOTO 3
C
C EEES
C
124   C(40)=12.
      C(42)=0.7
      C(43)=0.5
      C(41)=4.
      C(44)=-1.
      NK=13
C
C TANG, GRID, AXIS, BOND
C
125   K=3*NK
      NA=MAX0(NA,1)
      DO 126 J=1,NA
      C(K)=A(J)
126   K=K+1
      IF(5+MOD(NK,2)-NA)22,3,3
C
C TITL
C
127   DO 128 J=1,40
128   IT(J)=IR(J)
      GOTO 3
C
C PLAN
C
129   K=A(1)
      J=A(2)
      IN(9)=K+1000*J
      GOTO 3
C
C OMIT
C
130   IF(NA.EQ.3)GOTO 131
      C(31)=A(1)
      IF(NA-1)22,3,22
131   KZ=KZ+1
      H(KZ)=A(1)+100.*(A(2)+100.*A(3))
      IF(KZ-100)3,3,22
C
C HKLF
C
132   IF(C(45).LT.1.E-6)GOTO 57
      ME=NA
      CALL FREAD
      IF(IN(20))147,3,3
C
C END
C
133   IF(A(1)-0.9)135,134,134
134   LR=A(1)
      GOTO 3
135   X=IN(18)
      IF(X-4.5)137,136,136
136   X=2.
137   C(25)=(2.-C(23))*X
      IF(C(45).LT.1.E-6)GOTO 57
      C(45)=C(45)*SQRT(X)
      C(46)=UT*C(46)*C(46)
      IN(5)=MAX0(IN(5),IN(4)+2,IN(3)+5)
      I=IH(34)
      IF(MIN0(IN(8),IN(19)).LT.0)GOTO 22
      IF(MAX0(IN(8),IN(19))+IN(4).GT.IN(5)-1)GOTO 22
      J=IABS(IN(14))
C
C SIM FOURIER COEFFICIENTS
C
      IF((3-J)*(5-J))143,138,143
138   IF(L.GT.4329)IN(20)=-9
      Y=.0833333*C(25)*FLOAT(IN(1)-49)
      I=17
      K=IN(5)+4
139   I=I+4
      IF(I.GT.IN(6))GOTO 141
      M=IN(1)+103*((IN(I+2)-12)/2)+14
      L=MAX0(2,INT(ABS(C(K)*0.1)+1.5))+IN(4)
      Q=SIGN(0.5,C(K)+5.)
      X=Y*(AMOD(C(K)+5.,10.)-10.*Q)*(Q+AMOD(C(L)+5.,10.)-5.5)
      DO 140 N=1,51
      E(N)=E(N)-X*C(M)*C(M)
140   M=M+2
      K=K+IN(I)
      GOTO 139
141   X=0.
      Y=.0789568/(C(1)*C(1))
      DO 142 N=1,51
      C(N+4329)=2.*EXP(X)/AMAX1(E(N),1.E-5)
142   X=X+Y
143   L=IABS(IN(10))
      IF((2-J)*(3-J)*(5-J)*(1-L)*(5-L)*
     *MAX0(1-IABS(IN(11)),0))145,144,145
144   IF(IN(13).LT.-998)IN(13)=0
145   IF(MIN0(IN(13)+998,20-IN(6)))147,146,146
146   IN(20)=-7
C147   WRITE(LB,*)IT,JN,IN,C
147   DO 1000 I=1,40
1000  IIT(I)=IT(I)
      DO 1001 I=1,400
1001  JJN(I)=JN(I)
      DO 1002 I=1,1620
1002  IIN(I)=IN(I)
      DO 1003 I=1,4380
1003  CC(I)=C(I)
      KF=IN(20)
      RETURN
      END
C
      SUBROUTINE FREAD
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,
     *IT(40),H(100),F(84),C(4380),JN(400),IN(1620),IR(76),
     *IH(48),B(645),CF(100),A(200),E(52),IS(76),IP(20),D(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
C
C INTERPRET HKLF CARD
C
      NA=ME
      IK=0
      KK=0
      MR=0
      MS=0
      MN=0
      QM=.6332574*C(1)*C(1)
      PL=SQRT(ABS(C(8)*C(27)*C(27)+C(9)*C(28)*C(28)+C(10)*C(29)*C(29)
     *+C(11)*C(28)*C(29)+C(12)*C(27)*C(29)+C(13)*C(27)*C(28)))
      NN=0
      WT=1.
      LQ=LH
      IF(A(1).GT.0.)GOTO 1
      LQ=LR
1     UM=A(13)
      IF(NA-12)3,2,2
2     WT=A(12)
      NA=11
3     A(12)=-999.
      ME=IABS(INT(A(1)))
      IF(MIN0(ME,5-ME).LT.1)GOTO 106
      IF(NA-1)106,4,5
4     A(2)=1.
    5 IF (ME.EQ.4) A(2)=100.*A(2)
      IF (2-NA) 7,6,6
6     A(3)=1.
      A(7)=1.
      A(11)=1.
      NA=11
7     WT=WT*A(2)
      IF(NA.NE.11)GOTO 106
C
C FIND CORNERS
C
      IF(0.0001.GT.C(26))GOTO 46
      IF(KF.LT.0)GOTO 15
      KS=0
      N=39
      I=-3
8     I=I+4
      IF(I.EQ.KF)GOTO 14
      J=I
9     J=J+4
      IF(J.EQ.KF)GOTO 8
      Z=CF(I)*CF(J+1)-CF(I+1)*CF(J)
      Y=CF(I+2)*CF(J)-CF(I)*CF(J+2)
      X=CF(I+1)*CF(J+2)-CF(I+2)*CF(J+1)
      K=J
10    K=K+4
      IF(K.GT.KF)GOTO 9
      Q=CF(K)*X+CF(K+1)*Y+CF(K+2)*Z
      IF(.0001.GT.ABS(Q))GOTO 10
      U=(CF(I+3)*(CF(J+1)*CF(K+2)-CF(J+2)*CF(K+1))+CF(J+3)*(CF(I+2)*
     *CF(K+1)-CF(I+1)*CF(K+2))+CF(K+3)*X)/Q
      V=(CF(I+3)*(CF(J+2)*CF(K)-CF(J)*CF(K+2))+CF(J+3)*(CF(I)*CF(K+2)-
     *CF(I+2)*CF(K))+CF(K+3)*Y)/Q
      W=(CF(I+3)*(CF(J)*CF(K+1)-CF(J+1)*CF(K))+CF(J+3)*(CF(I+1)*CF(K)-
     *CF(I)*CF(K+1))+CF(K+3)*Z)/Q
C
C REJECT CORNERS
C
      M=39
11    M=M+3
      IF(M.GT.N)GOTO 12
      IF(ABS(U-A(M))+ABS(V-A(M+1))+ABS(W-A(M+2)).LT..00001)GOTO 10
      GOTO 11
12    DO 13 M=1,KF,4
      IF(.00001.LT.CF(M)*U+CF(M+1)*V+CF(M+2)*W-CF(M+3))GOTO 10
13    CONTINUE
      N=N+3
      IF(N.GT.155)GOTO 16
      A(N)=U
      A(N+1)=V
      A(N+2)=W
      GOTO 10
14    IF(N.GT.50)GOTO 17
15    IN(20)=-2
      GOTO 107
16    IN(20)=-9
      GOTO 107
C
C COUNT EDGES AND FIND LARGEST DEL(X)
C
17    T=-1.
      L=0
      DO 20 M=42,N,3
      DO 20 I=M,N,3
      K=0
      U=0.5*(A(M)+A(I))
      V=0.5*(A(M+1)+A(I+1))
      W=0.5*(A(M+2)+A(I+2))
      DO 18 J=1,KF,4
18    IF(.00001.GT.ABS(CF(J)*U+CF(J+1)*V+CF(J+2)*W-CF(J+3)))K=K+1
      U=ABS(A(M)-A(I))
      IF(T.GT.U)GOTO 19
      XB=A(I)
      XA=A(M)-XB
      T=U
19    IF(K.NE.2)GOTO 20
      L=L+1
      IF(L.GT.76)GOTO 16
      IR(L)=M
      IS(L)=I
20    CONTINUE
      I=(KF+3)/4
      J=(N-39)/3
      WRITE(LI,21)IT,I,J,L
21    FORMAT(27H1ABSORPTION CORRECTION FOR ,40A1/
     */I5,9H FACES  +,I4,11H CORNERS  =,I4,12H EDGES  +  2)
      IF(I+J-L.NE.2)GOTO 15
C
C SET UP GRID
C
      KG=I+3
      MX=LM-KG-LV-6868+(539*LU)
22    NG=1-KG
      VO=0.
      M=MIN0(8,MAX0(1,INT(.5+C(26)*C(53)*C(2)*T)))
      NK=M*M-M+1
      NN=M*M+M
      DO 29 I=NK,NN
      P=T*B(I+72)
      X=XA*B(I)+XB
      U=-1.
      J=0
23    J=J+1
      IF(J.EQ.L)GOTO 25
      NI=IR(J)
      NJ=IS(J)
      IF(0..GT.(A(NI)-X)*(X-A(NJ)))GOTO 23
      Y=(A(NI+1)-A(NJ+1))*(X-A(NJ))/(A(NI)-A(NJ))+A(NJ+1)
      K=J
24    K=K+1
      IF(K.GT.L)GOTO 23
      NI=IR(K)
      NJ=IS(K)
      IF(0..GT.(A(NI)-X)*(X-A(NJ)))GOTO 24
      Z=(A(NI+1)-A(NJ+1))*(X-A(NJ))/(A(NI)-A(NJ))+A(NJ+1)
      W=ABS(Z-Y)
      IF(U.GT.W)GOTO 24
      U=W
      YB=Z
      YA=Y-Z
      GOTO 24
25    M=MIN0(8,MAX0(1,INT(.5+C(26)*C(53)*C(3)*U)))
      NI=M*M-M+1
      NJ=M*M+M
      DO 29 J=NI,NJ
      Q=P*U*B(J+72)
      Y=YA*B(J)+YB
      W=1.E9
      V=-1.E9
      DO 27 K=1,KF,4
      IF(1.E-5.GT.ABS(CF(K+2)))GOTO 27
      Z=(CF(K+3)-CF(K)*X-CF(K+1)*Y)/CF(K+2)
      DO 26 M=1,KF,4
      IF(.00001.LT.CF(M)*X+CF(M+1)*Y+CF(M+2)*Z-CF(M+3))GOTO 27
26    CONTINUE
      V=AMAX1(V,Z)
      W=AMIN1(W,Z)
27    CONTINUE
      V=V-W
      M=MIN0(8,MAX0(1,INT(.5+C(26)*C(53)*C(4)*V)))
      NO=M*M-M+1
      K=M*M+M
      DO 29 M=NO,K
      NG=NG+KG
      IF(NG.LT.MX)GOTO 28
      C(26)=0.95*C(26)
      KS=1
      GOTO 22
28    D(NG+2)=V*Q*C(32)*B(M+72)
      VO=VO+D(NG+2)*1000.
      Z=V*B(M)+W
      NA=NG+3
      DO 29 NT=1,KF,4
      D(NA)=(CF(NT+3)-X*CF(NT)-Y*CF(NT+1)-Z*CF(NT+2))*C(53)
29    NA=NA+1
      NG=NG+3
      NO=(NG/KG)+1
      IF(KS.NE.0)WRITE(LI,30)
30    FORMAT(/21H ** PRECISION REDUCED)
      DO 31 I=1,L
      IR(I)=(IR(I)-39)/3
31    IS(I)=(IS(I)-39)/3
      WRITE(LI,32)NO,VO,C(53),(IR(I),IS(I),I=1,L)
32    FORMAT(/I6,31H GRID POINTS,  CRYSTAL VOLUME =,F12.8,
     *13H MM**3,  MU =,F8.2,5H CM-1//6H EDGES,14(I5,1H-,I2))
C
C DRAW CRYSTAL
C
      Z=SIN(.0174533*C(7))*HD
      A(169)=SQRT(19.73921/C(15))*HA
      A(174)=SQRT(19.73921/C(14))*HA
      A(172)=C(3)*C(17)*Z/C(20)
      A(177)=-C(2)*C(18)*Z/C(21)
      Z=C(4)*HD
      A(173)=-Z*SIN(.0174533*C(6))
      A(179)=Z*SIN(.0174533*C(5))
      DO 33 I=156,165,3
      A(I)=9.E8
33    A(I+1)=-9.E8
      DO 34 M=42,N,3
      DO 34 J=156,165,3
      Z=A(J+12)*A(M)+A(J+13)*A(M+1)+A(J+14)*A(M+2)
      A(J)=AMIN1(A(J),Z)
34    A(J+1)=AMAX1(A(J+1),Z)
      W=9.E8
      DO 35 J=156,165,3
35    W=AMIN1(W,AINT(132./(A(J+1)-A(J))))
      WRITE(LI,36)W
36    FORMAT(/16X,11HVIEW DOWN X,15X,20HCRYSTAL MAGNIFIED BY,
     *F8.0,15X,11HVIEW DOWN Y)
      L=0
      DO 39 M=42,N,3
      DO 37 I=1,10,3
37    IP(I)=INT(2.001+.3937*W*(A(I+167)*A(M)+A(I+168)*A(M+1)+
     *A(I+169)*A(M+2)-A(I+155)))
      IP(7)=IP(7)+64
      J=1
      K=7
      DO 38 I=1,KF,4
      IF(ABS(A(M)*CF(I)+A(M+1)*CF(I+1)+A(M+2)*CF(I+2)-
     *CF(I+3)).GT.0.00001)GOTO 38
      IF(CF(I).GT.0.)IP(J)=-IABS(IP(J))
      IF(CF(I+1).GT.0.)IP(K)=-IABS(IP(K))
38    CONTINUE
      IR(L+1)=IP(1)
      IS(L+1)=IP(4)
      L=L+2
      IR(L)=IP(7)
39    IS(L)=IP(10)
      DO 43 I=1,54
      DO 40 J=1,121
40    JN(J)=IH(48)
      N=1
      DO 42 J=1,L
      IF(IS(J).NE.I)GOTO 42
      K=IABS(IR(J))
      IF(JN(K).EQ.IH(13))GOTO 41
      M=(J+21)/20
      JN(K+1)=IH(M)
      M=1+MOD((J+1)/2,10)
      JN(K+2)=IH(M)
      N=MAX0(N,K+2)
      NA=IH(12)
      IF(IR(J).LT.0)NA=IH(13)
41    IF(JN(K).NE.IH(48))NA=IH(11)
      JN(K)=NA
42    CONTINUE
43    WRITE(LI,44)(JN(J),J=1,N)
44    FORMAT(1X,121A1)
      IF(C(30).LT.0.)WRITE(LI,45)
45    FORMAT(41H1  H   K   L   TRANSMISSION   SINSQ THETA,16X,4HMU*T/)
C
C READ CONDENSED DATA
C
46    IF(ME-2)49,59,63
47    X=1.
48    UM=UM+X*ABS(FLOAT(IP(NP)))
      UM=AINT(UM+SIGN(0.3,UM))
      GOTO 51
49    READ(LQ,50)IP
      KK=MOD(KK,99)+1
50    FORMAT(20I4)
      NP=0
51    NP=NP+1
      X=100.
      IF(NP.GT.20)GOTO 49
      IK=MOD(IK+KK*IP(NP),10000)
      IF(IP(NP))47,52,55
52    IF(20.GT.NP)GOTO 53
      READ(LQ,50)IP
      NP=0
53    NP=NP+1
      IF(IP(NP).EQ.0)GOTO 66
      IN(20)=-6
      IF(IP(NP).NE.IK)GOTO 107
      IN(20)=0
      WRITE(LI,54)
54    FORMAT(/14H CHECKSUM O.K.)
      GOTO 66
55    J=IP(NP)/1000
      IF(J)47,48,56
56    UM=UM+FLOAT(J)
      I=MOD(IP(NP)/100,10)-5
      W=WT/SQRT(FLOAT(MOD(IP(NP),100))*(10.**I))
      NP=NP+1
      IF(20-NP)57,58,58
57    READ(LQ,50)IP
      KK=MOD(KK,99)+1
      NP=1
58    J=(IP(NP)/1000)-4
      IK=MOD(IK+KK*IP(NP),10000)
      T=FLOAT(MOD(IP(NP),1000))*(10.**J)
      CALL HKL(UM,U,V,Z)
      NI=U
      NJ=V
      NK=Z
      GOTO 70
C
C MDM DATA
C
59    READ(LQ,60)IP
60    FORMAT(5(3I3,I7))
      NP=-3
61    NP=NP+4
      IF(NP.GT.20)GOTO 59
      NI=IP(NP)
      NJ=IP(NP+1)
      NK=IP(NP+2)
      T=IP(NP+3)
      W=0.
      NN=0
      GOTO 65
62    MN=MN+1
      IF(ME-2)51,61,63
C
C READ H,K,L, F OR I, SIGMA, N, COSINES
C
63    READ(LQ,64)NI,NJ,NK,T,W,NN,(A(I),I=51,56)
64    FORMAT(3I4,2F8.2,I4,6F8.5)
C
C TEST FOR END OF DATA (H=0, K=0, L=0)
C
65    IF(-IABS(NI)-IABS(NJ)-IABS(NK))68,66,66
66    WRITE(LI,67)MN,MR
67    FORMAT(/I6,26H REFLEXIONS READ, OF WHICH,I5,9H REJECTED/)
      GOTO 107
68    IF(T-0.0001)87,69,69
69    W=W*WT
      U=NI
      V=NJ
      Z=NK
70    X=U*A(3)+V*A(4)+Z*A(5)
      Y=U*A(6)+V*A(7)+Z*A(8)
      Z=U*A(9)+V*A(10)+Z*A(11)
      V=T*A(2)
C
C SYSTEMATIC ABSENCES
C
      U=ABS(AMOD(X,.9999))+ABS(AMOD(Y,.9999))+ABS(AMOD(Z,.9999))
      IF(0.1-U)83,71,71
71    U=X+Y
      J=IN(18)
      GOTO(78,74,72,75,76,73,77),J
72    IF(.1-ABS(AMOD(U+X+Z,2.9999)))83,78,78
73    U=X+Z
      GOTO 77
74    U=U+Z
      GOTO 77
75    IF(0.1-ABS(AMOD(U,1.9999)))83,76,76
76    U=Y+Z
77    IF(0.1-ABS(AMOD(U,1.9999)))83,78,78
78    U=-999999.
      P=0.
      R=0.
      J=IN(1)
      DO 82 I=61,J,12
      Q=X*C(I+2)+Y*C(I+5)+Z*C(I+8)
      CQ=X*C(I+1)+Y*C(I+4)+Z*C(I+7)
      CT=X*C(I)+Y*C(I+3)+Z*C(I+6)
      IF(49.5-AMAX1(ABS(CT),ABS(CQ)))87,87,79
79    Q=CT+100.*(CQ+100.*Q)
      Q=ABS(Q)*(1.-C(23))+Q*C(23)
      IF(Q-U+.01)82,80,80
80    P=P+1.
      O=6.283185*(X*C(I+9)+Y*C(I+10)+Z*C(I+11))
      O=COS(O)+21.42*SIN(O)*C(23)
      R=R+O
      IF(Q-U-0.5)82,81,81
81    P=1.
      R=O
      U=Q
82    CONTINUE
      IF(ABS(R)-.1)83,91,91
C
C ERRORS IN REFLECTION DATA
C
83    WRITE(LI,89)NI,NJ,NK,T
      GOTO 87
84    WRITE(LI,88)NI,NJ,NK,T
      GOTO 86
85    WRITE(LI,90)NI,NJ,NK,T
86    MS=MS+1
87    MR=MR+1
      IF(250-MS)106,106,62
88    FORMAT(3I4,F8.2,24H   BAD DIRECTION COSINES)
89    FORMAT(3I4,F8.2,24H   SYSTEMATICALLY ABSENT)
90    FORMAT(3I4,F8.2,29H   SIN THETA GREATER THAN ONE)
C
C REFLECTION GEOMETRY AND L.P.
C
91    QS=C(14)*X*X+C(15)*Y*Y+C(16)*Z*Z+C(17)*Y*Z+C(18)*X*Z+C(19)*X*Y
      O=QS*QM
      S=0.02*O
      Q=1.-S
      IF(Q)85,92,92
92    K=O
      O=AMOD(O,1.)
      EEE=EXP(0.05*QS)/SQRT((O*(E(K+2)-E(K+1))+E(K+1))*P)
      R=1.
      CL=0.
      IF(PL.LT.1.E-5)GOTO 94
      ST=SQRT(S)
      CT=SQRT(Q)
      CQ=C(1)/(PL*2.*ST)
      CL=C(27)*X+C(28)*Y+C(29)*Z
      CO=CQ*CL
      SO=SQRT(ABS(1.-CO*CO))
      R=ST*CT*SO/(0.5-Q*S)
      IF(0.0001.GT.C(26))GOTO 94
C
C EQUI-INCLINATION DIRECTION COSINES
C
      A(32)=Z
      A(33)=-Y
      A(34)=-Z
      A(36)=X
      A(37)=Y
      A(38)=-X
      A(21)=X*C(14)+0.5*(Z*C(18)+Y*C(19))
      A(22)=Y*C(15)+0.5*(X*C(19)+Z*C(17))
      A(23)=Z*C(16)+0.5*(X*C(18)+Y*C(17))
      K=51
      DO 93 I=1,3
      SP=SQRT(C(I+13))*.2250791
      P=C(1)*A(I+20)/(ST*SP*39.47842)
      O=SQRT(ABS(1.-P*P))
      CP=C(I+26)/(PL*SP)
      CP=(P*CO-CP)/AMAX1(.0001,SO*O)
      SP=SQRT(ABS(1.-CP*CP))
      SP=SIGN(O*CT*SP,1.E-6+C(8)*A(I+30)*C(27)+C(9)*A(I+33)*C(28)+
     *C(10)*A(I+36)*C(29)+0.5*(C(11)*(A(I+33)*C(29)+A(I+36)*C(28))+
     *C(12)*(A(I+30)*C(29)+A(I+36)*C(27))+C(13)*(A(I+30)*C(28)+
     *A(I+33)*C(27))))
      CP=P*ST
      A(K)=CP+SP
      A(K+1)=CP-SP
93    K=K+2
C
C CHECK DIRECTION COSINES
C
94    Q=0.
      IF(0.0001.GT.C(26))GOTO 102
      J=14
      DO 95 I=51,55,2
      CQ=SQRT(C(J))*.2250791
      A(I)=A(I)*CQ
      A(I+1)=A(I+1)*CQ
95    J=J+1
      DO 96 I=27,28
      A(I)=0.5*C(1)*(X*A(I+24)+Y*A(I+26)+Z*A(I+28))
96    CONTINUE
      IF(.001.LT.C(30)*AMAX1(ABS(A(27)-S),ABS(A(28)-S)))GOTO 84
C
C EVALUATE TRANSMISSION
C
      DO 97 I=1,NG,KG
      D(I)=1.E9
97    D(I+1)=1.E9
      DO 99 I=1,KF,4
      DO 99 J=1,2
      P=CF(I)*A(J+50)+CF(I+1)*A(J+52)+CF(I+2)*A(J+54)
      IF(P.LT..0001)GOTO 99
      P=1./P
      N=(I+15)/4
      DO 98 M=J,NG,KG
      D(M)=AMIN1(D(M),D(N)*P)
98    N=N+KG
99    CONTINUE
      T=0.
      DO 100 I=1,NG,KG
      X=AMIN1(15.656,D(I)+D(I+1))
      J=INT(32.*X)
      Z=D(I+2)*B(J+145)*(.9999229-.9845223*(X-.03125*FLOAT(J)))
100   T=T+Z
      T=T*1000./VO
      R=R/T
      Q=-ALOG(T)
      IF(C(30).LT.0.)WRITE(LI,101)NI,NJ,NK,T,S,A(27),A(28),Q
101   FORMAT(3I4,4F10.6,F10.4)
C
C STORE F(OBS) DATA
C
102   IF(ABS(CL-A(12)).GT.0.001)BN=BN+1000.
103   P=BN
      IF(NN.NE.0)P=FLOAT(1000*NN)
      A(12)=CL
      IF(IABS(ME-3).NE.1)GOTO 104
      V=SQRT(V*R)
      W=W*R/(V+V)
104   IF(W.LT.0.)QS=QS+UT
      F(MF+2)=1.E-10
      IF(ABS(W).GT.0.00001)F(MF+2)=W*W
      F(MF)=U
      F(MF+1)=V
      F(MF+3)=QS
      F(MF+4)=P+AMIN1(EEE*V,900.)
      F(MF+5)=-0.5*Q
      MF=MF+6
      IF(MF-LV)62,62,105
C105   WRITE(LF,*)F
105   ILF=ILF+1
      DO 122 I=1,84
122   FF(ILF,I)=F(I)
      MF=1
      GOTO 62
106   IN(20)=-15
107   RETURN
      END
C
      SUBROUTINE SMERG
      DIMENSION E(84)
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,
     *IT(40),H(100),F(84),B(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      DIMENSION IL(60000,4),FI(60000,2)
      IJK=0
      IF(KF.LT.0)GOTO 94
      KM=LM-LV-151+(19*LU)
      MM=B(54)
      MG=IABS(MM)
      TQ=B(31)
      SS=TQ*TQ
      IF(-1.E-6.GT.TQ)SS=0.
      BN=B(55)*6.28319
      SM=B(56)*6.28319
      SP=B(57)*6.28319
      SL=SQRT(B(25))*0.96
      IF(ME.EQ.0)GOTO 1
      F(MF)=0.
C      WRITE(LF,*)F
C      ENDFILE LF
C      REWIND LF
      ILF=ILF+1
      DO 123 I=1,84
123   FF(ILF,I)=F(I)
      ILF=0
1     IF(MG-1)79,57,2
C
C FIND H(MIN), H(MAX) ETC.
C
2     DO 3 I=4,6
      B(I)=999.
3     B(I+3)=-999.
      W=0.
C4     READ(LF,*)F
4      ILF=ILF+1
      DO 121 I=1,84
121   F(I)=FF(ILF,I)
      DO 5 I=1,LV,6
      IF(0.5.GT.ABS(F(I)))GOTO 6
      CALL HKL(F(I),B(1),B(2),B(3))
      W=AMAX1(W,F(I+4))
      DO 5 J=1,3
      B(J+3)=AMIN1(B(J+3),B(J))
5     B(J+6)=AMAX1(B(J+6),B(J))
      GOTO 4
C6     REWIND LF
6     ILF=0
      IF(0.001.GT.W)GOTO 93
      HB=B(7)-B(4)+1.
      GD=B(8)-B(5)+1.
      HC=1.5-B(4)-HB*(B(5)+GD*B(6))
      N=INT(0.001*W)
      NN=1
      B(1)=1.
      IF(MIN0(MG-1,N).LT.2)GOTO 37
      NN=N
C
C LAYER SCALING SORT
C
      NM=((NN+3)*NN)/2
      GA=FLOAT(NM)+HC
      NI=NM+1
      IF(NI+1000.GT.KM)GOTO 16
      DO 7 I=1,NM
7     B(I)=0.
      ASSIGN 8 TO NQ
8     M=KM
      L=KM+1
      DO 9 I=NI,KM
9     B(I)=0.
      NT=0
C10    READ(LF,*)F
10    ILF=ILF+1
      DO 131 I=1,84
131   F(I)=FF(ILF,I)
      DO 11 I=1,LV,6
      IF(0.5.GT.ABS(F(I)))GOTO 12
      CALL HKL(F(I),X,Y,Z)
      N=INT(GA+X+HB*(Y+GD*Z))
      IF(N.LT.NI)GOTO 11
      NT=MAX0(N,NT)
      IF(N.GT.M)GOTO 11
      B(N)=B(N)+1.
      IF(M.EQ.KM)GOTO 11
      N=B(N)
      IF(N.LT.L)B(N)=ALOG(F(I+1))+100.*AINT(0.001*F(I+4))+30.
11    CONTINUE
      GOTO 10
C12    REWIND LF
12    ILF=0
      IF(M.NE.KM)GOTO 17
      K=NM
13    K=K+1
      I=B(K)
      B(K)=L
      IF(K+I.GT.M)GOTO 15
      IF(I.LT.2)GOTO 14
      M=M-I
      B(K)=M
14    IF(NT.GT.K)GOTO 13
      ASSIGN 21 TO NQ
      K=K+1
15    NJ=M
      M=K-1
      GOTO 10
16    LV=-16
      GOTO 94
C
C L.S. SUMS FOR SCALE FACTORS
C
17    GA=GA-FLOAT(K-NI)
18    K=K-1
      IF(NI.GT.K)GOTO NQ,(8,21)
      I=B(K)
      IF(I.GT.KM)GOTO 18
      M=NJ+1
      NJ=I
      DO 20 I=M,NJ
      X=AMOD(B(I),100.)
      NL=INT(B(I)*0.01)
      NT=((NN+NN-NL+3)*NL)/2
      N=I
19    N=N+1
      IF(N.GT.NJ)GOTO 20
      L=INT(B(N)*0.01)
      IF(L.EQ.NL)GOTO 19
      Y=AMOD(B(N),100.)-X
      B(NL)=B(NL)+Y
      B(L)=B(L)-Y
      NK=MIN0(NL,L)
      NK=(((NN+NN-NK-1)*NK)/2)+L+NL
      B(NK)=B(NK)-1.
      NK=((NN+NN-L+3)*L)/2
      B(NK)=B(NK)+1.
      B(NT)=B(NT)+1.
      GOTO 19
20    CONTINUE
      GOTO 18
C
C INVERT MATRIX
C
21    J=NM
      DO 22 I=1,NN
      J=J+1
22    B(J)=B(I)
      K=0
      J=NN+1
      DO 26 NI=1,NN
      K=K+2
      I=J-1
      M=J+1
      B(J)=1./(B(J)+0.1)
      IF(NI-NN)23,26,26
23    B(K)=-B(J)*B(M)
      M=M+1
      K=K+1
      IF(K-J)23,25,25
24    B(M)=B(J)*B(L)+B(M)
      M=M+1
      L=L+1
      IF(I-L)25,24,24
25    L=J+NI-NN
      J=J+1
      IF(I-L)26,24,24
26    CONTINUE
      NI=NN-1
27    NI=NI-1
      J=K
      M=K+NI-NN
      L=M-1
      I=M+1
      K=I+NI-NN
28    B(I)=0.
      I=I+1
      IF(I-J)28,29,29
29    M=M+1
      B(M)=B(K)*B(J)+B(M)
      I=M
      NK=K+1
      IF(L-NK)31,30,30
30    J=J+1
      I=I+1
      B(I)=B(K)*B(J)+B(I)
      B(M)=B(NK)*B(J)+B(M)
      NK=NK+1
      IF(L-NK)31,30,30
31    B(NK)=B(K)*B(M)+B(NK)
      J=J+1
      K=K+1
      IF(L-K)32,29,29
32    IF(-NI)27,33,33
33    DO 34 I=1,NN
34    B(I)=0.
      L=NN+1
      DO 36 I=1,NN
      NM=NM+1
      B(I)=B(I)-B(L)*B(NM)
      N=NM
      DO 35 K=I,NN
      B(I)=B(L)*B(N)+B(I)
      B(K)=B(L)*B(NM)+B(K)
      N=N+1
35    L=L+1
36    B(I)=EXP(B(I))
C
C SORT/MERGE
C
37    GA=FLOAT(NN)+HC
      WRITE(LI,38)IT
38    FORMAT(16H1SORT-MERGE FOR ,40A1)
      NI=NN+1
      ASSIGN 41 TO NQ
      NE=-5
      R=0.
      S=0.
      NM=0
      IF(MG.GT.2)WRITE(LI,39)(B(I),I=1,NN)
39    FORMAT(//26H INTER-LAYER SCALE FACTORS//(10F12.4))
      WRITE(LI,40)
40    FORMAT(//16H INCONSISTENCIES//
     *33H   H   K   L   ESD/F  SIGMA/F   N/)
41    DO 42 J=NI,KM
42    B(J)=0.
      NT=0
      M=KM
C43    READ(LF,*)F
43    ILF=ILF+1
      DO 132 I=1,84
132   F(I)=FF(ILF,I)
      DO 45 I=1,LV,6
      IF(0.5.GT.ABS(F(I)))GOTO 46
      CALL HKL(F(I),X,Y,Z)
      N=INT(GA+X+HB*(Y+GD*Z))
      IF(N.LT.NI)GOTO 45
      IF(N.GT.M)GOTO 45
      IF(M.EQ.KM)GOTO 44
      N=B(N)
      L=1
      IF(MG.GT.2)L=INT(0.001*F(I+4))
      V=F(I+1)*B(L)
      W=1./(F(I+2)*B(L)*B(L))
      B(N+1)=B(N+1)+V*W
      B(N+2)=B(N+2)+W
      B(N+3)=AMOD(F(I+3),UT)
      B(N+4)=B(N+4)+AMOD(F(I+4),1000.)*W*B(L)
      B(N+5)=B(N+5)+F(I+5)*W
      B(N+6)=B(N+6)+V*V*W
      B(N+7)=F(I)
44    B(N)=B(N)+1000.
45    NT=MAX0(N,NT)
      GOTO 43
C46    REWIND LF
46    ILF=0
      IF(M.NE.KM)GOTO 51
      K=NN
47    K=K+1
      IF(K+10.GT.M)GOTO 49
      IF(B(K).LT.1.)GOTO 48
      M=M-8
      B(K)=M+1
48    IF(NT.GT.K)GOTO 47
      ASSIGN 55 TO NQ
      K=K+1
49    DO 50 I=K,KM
50    B(I)=0.
      M=K-1
      GOTO 43
C
C R-INDEX AND INCONSISTENCIES
C
51    GA=GA-FLOAT(K-NI)
      K=K-1
      DO 53 J=NI,K
      M=B(J)
      IF(M.EQ.0)GOTO 53
      NE=NE+6
      E(NE)=B(M+7)
      W=1./B(M+2)
      E(NE+1)=B(M+1)*W
      E(NE+2)=W
      E(NE+3)=B(M+3)
      E(NE+4)=B(M)+AMIN1(900.,B(M+4)*W)
      E(NE+5)=B(M+5)*W
      IF(NE.LT.LV)GOTO 52
C      WRITE(LA,*)E
      ILA=ILA+1
      DO 200 I=1,84
200   EE(ILA,I)=E(I)
      NE=-5
52    NM=NM+1
      IF(1500..GT.B(M))GOTO 53
      IF(1.E-8.GT.B(M+1))GOTO 53
      X=B(M+2)*B(M+6)
      Y=B(M+1)*B(M+1)
      S=S+W*X*(B(M)-1000.)
      R=R+W*B(M)*(X-Y)
      IF(1.04*Y.GT.X)GOTO 53
      U=1./(SQRT(W)*B(M+1))
      W=SQRT(ABS(X/Y-1.))
      N=INT(0.001*B(M)+0.1)
      CALL HKL(B(M+7),X,Y,Z)
      I=X
      L=Y
      M=Z
      IF(W.GT.U+U)WRITE(LI,54)I,L,M,W,U,N
53    CONTINUE
54    FORMAT(3I4,2F8.3,I5)
      GOTO NQ,(41,55)
55    E(NE+6)=0.
C      WRITE(LA,*)E
      ILA=ILA+1
      DO 201 I=1,84
201   EE(ILA,I)=E(I)
      T=0.
      IF(S.NE.0.)T=SQRT(ABS(R/S))
      WRITE(LI,56)NM,T
56    FORMAT(//I7,23H UNIQUE REFLEXIONS, R =,F8.4)
      GOTO 60
C57    READ(LF,*)F
57    ILF=ILF+1
      DO 133 I=1,84
133   F(I)=FF(ILF,I)
C      WRITE(LA,*)F
      ILA=ILA+1
      DO 202 I=1,84
202   EE(ILA,I)=F(I)
      DO 58 I=1,LV,6
      IF(0.5.GT.ABS(F(I)))GOTO 59
58    CONTINUE
      GOTO 57
C59    REWIND LF
59    ILF=0
60    ILA=0
C      ENDFILE LA
C      REWIND LA
C
C NORMALISE E-VALUES
C
      IF(MM.LT.0)WRITE(LI,61)
61    FORMAT(//1X,4(5X,25HH  K  L     F   SIG(F)  N)/)
      L=0
      DO 62 I=1,64
      B(I)=0.
62    E(I)=0.
      DO 77 M=1,2
C63    READ(LA,*)F
63    ILA=ILA+1
      DO 203 I=1,84
203   F(I)=EE(ILA,I)
      I=-5
64    I=I+6
      IF(0.5.GT.ABS(F(I)))GOTO 72
      X=1.+SQRT(2.584724*AMOD(F(I+3),UT))
      K=MIN0(14,INT(X))
      T=AMIN1(X-FLOAT(K),1.)
      W=AMOD(F(I+4),1000.)
      P=1.-T
      IF(M.GT.1)GOTO 65
      B(K)=B(K)+P*W*W
      B(K+1)=B(K+1)+T*W*W
      B(K+15)=B(K+15)+P
      B(K+16)=B(K+16)+T
      GOTO 69
65    W=W*(P*B(K+30)+T*B(K+31))
      N=INT(0.001*F(I+4))
      F(I+4)=AMIN1(W,9.0)
      IF(MG.LT.2)F(I+4)=F(I+4)+FLOAT(1000*N)
      F(I+3)=AMOD(F(I+3),UT)
      IF(SS.GT.1.E9)GOTO 66
      IF(F(I+2)*SS.GT.F(I+1)*F(I+1))N=-N
66    F(I+1)=F(I+1)*Q
      F(I+2)=F(I+2)*Q*Q
      IF(TQ.LT.-1.E-6)F(I+2)=TQ*TQ
      V=ABS(1.-W*W)
      B(K)=B(K)+P*V/AMAX1(B(K+15),0.01)
      B(K+1)=B(K+1)+T*V/AMAX1(B(K+16),0.01)
      CALL HKL(F(I),X,Y,Z)
      IF(L.LT.4)GOTO 68
      IF(MM.LT.0)WRITE(LI,67)(IT(K),IT(K+4),IT(K+8),B(K+45),
     *B(K+49),IT(K+12),K=1,4)
67    FORMAT(1X,4(I6,2I3,F8.2,F6.2,I4))
C
C MODIF ALB FOR OUTPUT FILE.NEW
C      
      IF(MM.GE.0)GO TO 671
      DO 672 K=1,4
      IJK=IJK+1
      IL(IJK,1)=IT(K)
      IL(IJK,2)=IT(K+4)
      IL(IJK,3)=IT(K+8)
      FI(IJK,1)=B(K+45)
      FI(IJK,2)=B(K+49)
672   IL(IJK,4)=IT(K+12)
671   L=0
68    L=L+1
      IT(L)=X
      IT(L+4)=Y
      IT(L+8)=Z
      IT(L+12)=N
      B(L+45)=F(I+1)
      B(L+49)=SQRT(F(I+2))
69    IF(I.LT.LV)GOTO 64
C      IF(M.EQ.2)WRITE(LF,*)F
      IF(M.NE.2)GO TO 122
      ILF=ILF+1
      DO 124 I=1,84
124   FF(ILF,I)=F(I)
122      GOTO 63
70    FORMAT(18H SIN(THETA)/LAMBDA,F5.2,14F7.2//10H R.M.S.(E),6X,15F7.3)
71    FORMAT(/16H MEAN ABS(E*E-1),15F7.3//16H EFFECTIVE N    ,15F7.1/)
72    IF(M.EQ.2)GOTO 77
      Q=1.
      U=0.
      DO 75 J=1,10
      DO 73 I=1,8
73    E(I)=0.
      DO 74 I=1,15
      X=E(8)*E(8)
      P=EXP(X*U)*B(I)
      V=P/AMAX1(1.E-5,B(I+15))
      W=P*Q
      Z=B(I+15)-W
      E(1)=E(1)+V*P
      W=W*X
      E(2)=E(2)+V*W
      P=Q*X
      E(3)=E(3)+V*W*P
      E(4)=E(4)+Z*V
      E(5)=E(5)+Z*V*P
      E(6)=E(6)+B(I)
      E(7)=E(7)+B(I+15)
74    E(8)=E(8)+.622004
      X=1./(0.1+E(1))
      W=-X*E(2)
      Z=1./(0.1+E(3)+W*E(2))
      Y=Z*W
      X=X+W*Y
      U=U+E(4)*Y+E(5)*Z
      IF (ABS(U).LT.0.1) GO TO 75
      U=SIGN(0.09999,U)
      X=0.
      Y=1./(0.1+E(3))
75    Q=Q+E(4)*X+E(5)*Y
      Q=SQRT(Q)*SL
      U=0.05-0.5*U
      X=0.0001
      DO 76 I=1,15
      B(I+30)=SQRT((B(I+15)+0.01*E(7))/(B(I)+0.01*E(6)))
      E(I+15)=B(I+30)*SQRT(B(I)/AMAX1(B(I+15),0.0001))+0.00001
      B(I)=0.00001
      E(I)=X
76    X=X+0.07
C77    REWIND LA
77    ILA=0
      IF(MM.LT.0)WRITE(LI,67)(IT(K),IT(K+4),IT(K+8),B(K+45),B(K+49),
     *IT(K+12),K=1,L)
C
C   MODIF ALB FOR OUTPUT *.NEW
C
      IF(MM.GE.0)GO TO 674
      DO 673 K=1,L
      IJK=IJK+1
      IL(IJK,1)=IT(K)
      IL(IJK,2)=IT(K+4)
      IL(IJK,3)=IT(K+8)
      FI(IJK,1)=B(K+45)
      FI(IJK,2)=B(K+49)
673   IL(IJK,4)=IT(K+12)
674   CONTINUE
C      WRITE(LF,*)F
C      ENDFILE LF
C      REWIND LF
      ILF=ILF+1
      DO 125 I=1,84
125   FF(ILF,I)=F(I)
      ILF=0
78    FORMAT(//14H OVERALL SCALE,F12.5,10X,13HESTIMATED U =,F6.3//)
      WRITE(LI,78)Q,U
      WRITE(LI,70)(E(I),I=1,30)
      WRITE(LI,71)(B(I),I=1,30)
C
C EDIT AND RENORMALISE
C
79    N=0
      M=0
      DO 80 I=1,16
      B(I)=0.
80    E(I)=0.
      R=ABS(BN)+ABS(SM)+ABS(SP)
      IF(R.GT.1.E-6)GOTO 81
      IF(KZ.GT.0)GOTO 81
      IF(SS.GT.1.E9)GOTO 94
C81    READ(LF,*)F
81    ILF=ILF+1
      DO 134 I=1,84
134   F(I)=FF(ILF,I)
C      WRITE(LA,*)F
      ILA=ILA+1
      DO 204 I=1,84
204   EE(ILA,I)=F(I)
      DO 82 I=1,LV,6
      IF(0.5.GT.ABS(F(I)))GOTO 83
      IF(R.LT.1.E-6)GOTO 82
      Q=AMOD(F(I+4),1000.)
      Q=Q*Q
      CALL HKL(F(I),X,Y,Z)
      P=COS(X*BN+Y*SM+Z*SP)*4.99+6.
      K=INT(P)
      P=P-FLOAT(K)
      Z=1.-P
      B(K)=B(K)+Q*Z
      E(K)=E(K)+Z
      B(K+1)=B(K+1)+Q*P
      E(K+1)=E(K+1)+P
82    N=N+1
      GOTO 81
C83    REWIND LF
83    ILF=0
C      ENDFILE LA
C      REWIND LA
      ILA=0
      IF(R.LT.1.E-6)GOTO 86
      S=-1.
      DO 84 I=1,11
      W=1./AMAX1(0.001,E(I))
      P=B(I)*S
      E(12)=E(12)+W*B(I)*B(I)
      E(13)=E(13)+W*B(I)*P
      E(14)=E(14)+W*P*P
      E(15)=E(15)+B(I)
      E(16)=E(16)+P
84    S=S+0.2
      P=1./AMAX1(0.01,E(12)*E(14)-E(13)*E(13))
      S=P*(E(15)*E(14)-E(13)*E(16))
      T=P*(E(12)*E(16)-E(13)*E(15))
      X=BN*.159155
      Y=SM*.159155
      Z=SP*.159155
      WRITE(LI,85)S,T,X,Y,Z
85    FORMAT(//24H NEW E*E = (OLD E*E) * (,F7.4,2H +,F7.4,
     *12H*COS( 2*PI*(,F7.4,4H*H +,F7.4,4H*K +,F7.4,8H*L ) ) ))
C86    READ(LA,*)F
86    ILA=ILA+1
      DO 205 I=1,84
205   F(I)=EE(ILA,I)
      DO 90 I=1,LV,6
      IF(0.5.GT.ABS(F(I)))GOTO 91
      X=0.
      J=0
87    J=J+1
      IF(J.GT.KZ)GOTO 88
      IF(0.5.GT.ABS(F(I)-H(J)))X=1.1
      GOTO 87
88    IF(SS.GT.1.E9)GOTO 89
      IF(SS*F(I+2).GT.F(I+1)*F(I+1))X=1.1
   89 M=M+INT(X)
      IF(R.LT.1.E-6)GOTO 90
      CALL HKL(F(I),P,Y,Z)
      F(I+4)=F(I+4)+AMOD(F(I+4),1000.)*(SQRT(ABS(S+T*
     *COS(P*BN+Y*SM+Z*SP)))-1.)
90    F(I+3)=AMOD(F(I+3),UT)+UT*AINT(X)
C      WRITE(LF,*)F
      ILF=ILF+1
      DO 126 I=1,84
126   FF(ILF,I)=F(I)
      GOTO 86
C91    WRITE(LF,*)F
C      ENDFILE LF
91    ILF=ILF+1
      DO 127 I=1,84
127   FF(ILF,I)=F(I)
92    FORMAT(///I6,30H REFLECTIONS SUPPRESSED OUT OF,I6)
      WRITE(LI,92)M,N
C      REWIND LF
      ILF=0
C      REWIND LA
      ILA=0
      GOTO 94
93    LV=-17
94    CONTINUE
CCC  
CCC  MODIF ALB for .NEW file
CCC   SIG(I)=SIG(F)*F*2.
CCC
C      IF(IJK.NE.NM)PRINT *,'? NM SHOULD BE EQUAL TO IJK'
      FMAXF2=0.
      DO 680 I=1,IJK
      FI(I,2)=FI(I,2)*FI(I,1)*2.
      FI(I,1)=FI(I,1)*FI(I,1)
      IF(FI(I,1).GT.FMAXF2)FMAXF2=FI(I,1)
680   CONTINUE
      FMAXF2=5000./FMAXF2
      DO 681 I=1,IJK
      FI(I,1)=FI(I,1)*FMAXF2
      FI(I,2)=FI(I,2)*FMAXF2
      WRITE(LA,670)(IL(I,J),J=1,3),(FI(I,K),K=1,2),IL(I,4)
681   CONTINUE
670   FORMAT(3I4,2F8.2,I4)
      I0=0
      B0=0.
      WRITE(LA,670)I0,I0,I0,B0,B0,IO
CCC
CCC
CCC
      RETURN
      END
C
      SUBROUTINE ATFIX
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS,
     * NP,KH,NA,NH,R,SF,DA,IT(40),JN(400),IN(1620),C(4380),ID(2000),
     * IX(1200),E(510),A(510),H(2000),D(4000),F(84),DX(1200),G(141),
     * ES(2000),B(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
C      READ(LB,*)IT,JN,IN,C
      DO 1000 I=1,40
1000  IT(I)=IIT(I)
      DO 1001 I=1,400
1001  JN(I)=JJN(I)
      DO 1002 I=1,1620
1002  IN(I)=IIN(I)
      DO 1003 I=1,4380
1003  C(I)=CC(I)
      IF(LV.LT.0)IN(20)=LV
      IF(IN(20))59,1,1
1     X=0.
      DO 2 I=1,126
      G(I)=SIN(X)
2     X=X+6.283185E-2
      B(1)=C(4)/C(3)
      B(2)=C(2)/C(4)
      B(3)=C(3)/C(2)
      DO 3 J=1,3
      Y=.0174533*C(J+4)
      Z=1./SIN(Y)
      B(J+6)=C(J+16)/C(J+19)
      G(J+126)=COS(Y)*Z
      G(J+129)=B(J)*Z
3     G(J+132)=Z/B(J)
      G(136)=B(9)*G(130)/G(134)
      G(139)=B(8)*G(133)/G(132)
      G(137)=B(7)*G(131)/G(135)
      G(140)=B(9)*G(134)/G(130)
      G(138)=B(8)*G(132)/G(133)
      G(141)=B(7)*G(135)/G(131)
      NS=IN(1)+12
      NE=IN(4)+1
      SF=AINT(1.99-0.01*C(NE))
      NP=IN(4)-IN(3)-7
      NC=0
      NV=IABS(IN(13))
      IF(IN(13).LT.-998)NV=-1
      DO 4 J=1,1100
4     A(J)=0.
C
C ATOM CO-ORDINATES
C
      JI=0
      N=-2
      M=-2
      K=IN(5)+1
      I=17
5     I=I+4
      IF(I.GT.IN(6))GOTO 30
      IF(JI.NE.8)GOTO 6
      IF(IN(I+1).LT.80)N=-2
6     JI=IN(I+1)/10
      DO 8 J=1,3
      L=MAX0(1,INT(ABS(C(K)*0.1)+0.5))+NE
      IF(IN(5)-L)58,7,7
7     R=SIGN(0.5,C(K)+5.)
      NJ=J+N+2
      IF(JI.EQ.8)C(K)=H(NJ)+C(50)*(H(NJ)-B(J))/Q
      H(NJ)=(AMOD(C(K)+5.,10.)-10.*R)*(R+AMOD(C(L)+5.,10.)-5.5)
8     K=K+1
      K=K-3
      IF(JI.EQ.8)GOTO 26
C
C BENZENE AND CYCLOPENTADIENIDE RINGS
C
      NI=12
      IF(JI-5)27,10,9
9     NI=16
10    N=N+3
      IX(N)=K
      IF(NI-N)11,13,29
11    DO 12 J=1,3
12    B(J)=.2*(H(J)+H(J+3)+H(J+6)+H(J+9)+H(J+12))
      Q=C(51)*.8506508
      NX=3
      NI=13
      GOTO 18
13    DO 14 J=1,3
14    B(J)=.3333333*(H(J)+H(J+6)+H(J+12))
      Q=C(52)
      NX=6
      IF(JI-6)18,15,18
15    DO 16 J=1,3
16    B(J)=0.5*B(J)+.1666667*(H(J+3)+H(J+9)+H(J+15))
      DO 17 J=1,3
      H(J)=0.5*(H(J)-H(J+9))+B(J)
      H(J+6)=0.5*(H(J+6)-H(J+15))+B(J)
17    H(J+12)=0.5*(H(J+12)-H(J+3))+B(J)
18    L=1
      DO 21 J=1,100
      DO 19 NT=1,3
      NJ=MOD(L+5,NI+2)+1
      NL=MOD(L+5+NX,NI+2)+1
      B(NT+3)=B(NT)-0.5*(H(NJ)+H(NL))
19    L=L+1
      R=Q/SQRT(C(8)*B(4)*B(4)+C(9)*B(5)*B(5)+C(10)*B(6)*B(6)
     *+C(11)*B(5)*B(6)+C(12)*B(4)*B(6)+C(13)*B(4)*B(5))
      L=MOD(L-4,NI+2)+1
      DO 20 NT=1,3
      H(L)=B(NT)+R*B(NT+3)
20    L=L+1
21    L=MOD(L+NX-4,NI+2)+1
      IF(NI-15)24,24,22
22    DO 23 J=1,3
      H(J+3)=B(J)+B(J)-H(J+12)
      H(J+9)=B(J)+B(J)-H(J)
23    H(J+15)=B(J)+B(J)-H(J+6)
   24 I=I-(4*NI+8)/3
      DO 25 J=1,NI,3
      L=IX(J)
      M=M+3
      I=I+4
      ID(I)=M
      D(M)=H(J)
      D(M+1)=H(J+1)
      D(M+2)=H(J+2)
      C(L)=H(J)
      C(L+1)=H(J+1)
25    C(L+2)=H(J+2)
      N=-2
      GOTO 29
26    IF(NI.LT.13)GOTO 58
      N=N+3
      IF(NI-N)58,29,29
C
C FREE ATOMS
C
27    IF(JI)58,28,29
28    M=M+3
      D(M)=H(N+3)
      D(M+1)=H(N+4)
      D(M+2)=H(N+5)
29    ID(I)=M
      K=K+IN(I)
      GOTO 5
C
C HYDROGEN ATOMS
C
30    K=IN(5)+1
      I=17
      H(1)=-1.
      NQ=0
      KH=0
31    I=I+4
      IF(IN(6)-I)59,32,32
32    N=(IN(I+1)/10)
      KH=MAX0(IN(I+3),KH)
      NK=ID(I)
      IF((5-N)*N)52,52,33
33    IF(NQ-5)34,57,57
34    L=-2
      NI=1
      IF(NK)58,58,35
35    L=L+3
      IF(M-L)41,36,36
36    X=D(L)-D(NK)
      Y=D(L+1)-D(NK+1)
      Z=D(L+2)-D(NK+2)
      R=X*X*C(8)+Y*Y*C(9)+Z*Z*C(10)+Y*Z*C(11)+X*Z*C(12)+X*Y*C(13)
      R=SQRT(R)
      NJ=NI+4
      NL=NJ
37    NJ=NJ-4
      IF(R-H(NJ))37,39,39
38    H(NL+7)=H(NL+3)
      H(NL+6)=H(NL+2)
      H(NL+5)=H(NL+1)
      H(NL+4)=H(NL)
39    NL=NL-4
      IF(NJ-NL)38,40,40
40    H(NJ+4)=R
      H(NJ+5)=X
      H(NJ+6)=Y
      H(NJ+7)=Z
      NI=MIN0(NI+4,21)
      GOTO 35
41    Q=C(50)
      NL=17
      GOTO(45,43,42,44),N
42    Q=Q*.3333333
      NL=9
      IF(NI-13)58,45,45
43    Q=Q*.5773503
C
C C-H
C
44    NL=13
45    IF(NL-NI)46,46,58
46    ND=K+2
      DO 47 J=1,3
      B(J)=0.
      DO 47 NJ=9,NL,4
      NT=J+NJ
47    B(J)=B(J)-H(NT)/AMAX1(H(NJ),0.01)
      Q=Q/(1.E-8+SQRT(B(1)*B(1)*C(8)+B(2)*B(2)*C(9)+
     *B(3)*B(3)*C(10)+B(2)*B(3)*C(11)+B(1)*B(3)*C(12)+B(1)*B(2)*C(13)))
      NT=1
      DO 48 J=K,ND
      C(J)=D(NK)+Q*B(NT)
      NK=NK+1
48    NT=NT+1
      GOTO(52,49,49,52),N
C
C CH2
C
49    X=H(11)*H(16)-H(15)*H(12)
      Y=H(12)*H(14)-H(10)*H(16)
      Z=H(10)*H(15)-H(11)*H(14)
      B(5)=C(14)*X+0.5*(C(19)*Y+C(18)*Z)
      B(6)=C(15)*Y+0.5*(C(17)*Z+C(19)*X)
      B(7)=C(16)*Z+0.5*(C(18)*X+C(17)*Y)
      B(4)=C(50)*.8164966/(1.E-8+SQRT(B(5)*B(5)*C(8)+B(6)*B(6)*C(9)+
     *B(7)*B(7)*C(10)+B(6)*B(7)*C(11)+B(5)*B(7)*C(12)+B(5)*B(6)*C(13)))
      GOTO(58,50,53,55),N
50    L=K
      DO 51 J=5,7
      H(J)=C(L)+B(J)*B(4)
      C(L)=C(L)-B(J)*B(4)
51    L=L+1
      NQ=5
52    K=K+IN(I)
      GOTO 31
C
C CH3
C
53    N=4
      DO 54 J=4,7
54    H(J+9)=B(J)
      GOTO 49
55    NQ=8
      L=K
      DO 56 J=5,7
      H(J)=C(L)-.5773503*B(4)*B(J)+H(13)*H(J+9)
      H(J+3)=H(J)-2.*H(13)*H(J+9)
      C(L)=C(L)+1.154701*B(4)*B(J)
56    L=L+1
      GOTO 52
57    C(K)=H(NQ)
      C(K+1)=H(NQ+1)
      C(K+2)=H(NQ+2)
      NQ=NQ-3
      GOTO 52
C
C ERROR CHECK
C
58    J=(I/4)-4
      IN(1)=JN(J)
      IN(20)=-5
C59    WRITE(LB,*)IT,JN,IN,C
59    DO 1004 I=1,40
1004  IIT(I)=IT(I)
      DO 1005 I=1,400
1005  JJN(I)=JN(I)
      DO 1006 I=1,1620
1006  IIN(I)=IN(I)
      DO 1007 I=1,4380
1007  CC(I)=C(I)
      DO 60 I=1,2000
60    ES(I)=0.
      RETURN
      END
C
      SUBROUTINE XREF
      DIMENSION IH(18)
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS,
     * NP,KH,NA,NH,R,SF,DA,IT(40),JN(400),IN(1620),C(4380),ID(2000),
     * IX(1200),E(510),A(510),H(2000),D(4000),F(84),DX(1200),G(141),
     * ES(2000),B(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      DATA IH(1)/4H X/A/,IH(2)/4H Y/B/,IH(3)/4H Z/C/,IH(4)/4H  K /
      DATA IH(5)/4H U11/,IH(6)/4H U22/,IH(7)/4H U33/,IH(8)/4H U23/
      DATA IH(9)/4H U13/,IH(10)/4H U12/,IH(11)/1H /,IH(12)/1H0/
      DATA IH(13)/4HILSF/,IH(14)/4HFVAR/,IH(15)/4H    /
      DATA IH(16)/4HROTX/,IH(17)/4HROTY/,IH(18)/4HROTZ/
      MPR=MIN0(500,INT(SQRT(FLOAT(LM+LM+(5259*LU)-40096-LV-LV))-1.5))
      KB=1
      IF(IN(20))113,1,1
1     NC=NC+1
      KB=KB+KB
      IF(KH.GT.0)IN(13)=-IABS(IN(13))
      IF(KB.GT.KH)KB=2
      R=0.
C
C PUNCH CARDS
C
      JI=0
      K=IN(5)
      IF(NV)10,2,10
2     WRITE(LI,3)IT
3     FORMAT(///1X,40A1//)
      WRITE(LI,4)(IH(J),J=1,10)
4     FORMAT(5H ATOM,3(5X,A4),2(8X,A4),5(5X,A4)/)
      IF(C(60).LT.9.E8)WRITE(LP,5)C(60),IN(19),IN(8)
5     FORMAT(4HWGHT,F11.6,2I4)
      IF(IN(12))6,8,6
6     J=IN(3)+6
      C(J)=IN(12)
      NT=IN(4)
      WRITE(LP,7)(C(I),I=J,NT)
7     FORMAT(4HILSF,7F10.5)
      C(J)=1.
8     J=IN(4)+2
      C(J)=C(J-1)
      WRITE(LP,9)(C(I),I=J,K)
9     FORMAT(4HFVAR,7F10.5)
      C(J)=1.
10    NH=0
      NZ=-1
      NA=-2
      MM=0
      NN=IN(5)-IN(3)-7
      NCS=0
      NER=-5
      I=17
11    I=I+4
      JI=JI+1
      IF(IN(6)-I)46,12,12
C
C PARAMETER VALUES
C
12    J=MOD(IN(I+1),10)
      IF(IN(I+3).EQ.0)GOTO 13
      IF(MOD(IN(I+3)/KB,2).EQ.0)J=2
13    NQ=MIN0(5,3*((J-1)/2),3*(7-J))
      IN(I+3)=J
      IF(NV.EQ.0)IN(I+3)=2
      NF=MIN0(MOD(J,2),IABS(J-5))
      IF(NF*4-NQ)15,14,14
14    NZ=NH
      ND=K
15    IF(J-6)16,18,17
16    MM=0
      GOTO 19
17    MM=NN+1
      NN=NN+3
      GOTO 19
18    NA=NA+3
      IX(NA)=MM
      IX(NA+1)=NH+1
      IX(NA+2)=K+1
      DX(NA)=C(K+1)-C(ND+1)
      DX(NA+1)=C(K+2)-C(ND+2)
      DX(NA+2)=C(K+3)-C(ND+3)
      IF(MM)44,44,19
19    NL=IN(I)
      IF(NZ)44,20,20
20    NW=NZ
      DO 29 J=1,NL
      K=K+1
      M=INT(ABS(C(K)*0.1)+0.5)
      E(J)=C(K)
      NH=NH+1
      ID(NH)=(NN*NF)+1
      NN=NN+NF
      IF(M-1)25,21,21
21    ID(NH)=(M+NP)*NF+1
      NN=NN-NF
      NR=M+IN(4)+1
      IF(IN(5)-NR)44,22,22
22    Q=SIGN(0.5,C(K)+5.)
      H(NH)=AMOD(C(K)+5.,10.)-10.*Q
      C(K)=H(NH)*(Q+AMOD(C(NR)+5.,10.)-5.5)
      IF(5.-C(NR))24,23,23
23    IF(1-M)26,24,24
24    ID(NH)=1
25    H(NH)=1.
26    NW=NW+1
      IF((NW-NH)*((M*ID(NW))-1))44,27,27
27    ID(NH)=ID(NW)
      H(NH)=H(NW)
      M=ID(NH)
      E(J+10)=C(K)
      E(J+20)=ABS(A(M)*H(NH))
      IF(NQ-J)29,28,29
28    NF=1-NF
      NW=NH
29    IF(KH.NE.0)E(J+20)=ES(NH)
C
C PRINT TABLES AND TEST FOR N.P.D.
C
      IF(NV)11,30,11
30    WRITE(LI,31)IH(12),JN(JI),(E(J+10),J=1,NL)
      WRITE(LI,31)IH(11),IH(15),(E(J+20),J=1,NL)
31    FORMAT(A1,A4,2X,3F9.4,2F12.4,5F9.4)
      IF(7-NL)33,32,32
32    IF(E(15))36,38,38
33    V=E(15)*E(16)*E(17)
      DO 35 J=15,17
      IF(E(J))36,34,34
34    U=(V/E(J))-E(J+3)*E(J+3)
      IF(U)36,35,35
35    CONTINUE
      U=U*E(17)+2.*E(18)*E(19)*E(20)
      IF(U-E(16)*E(19)*E(19)-E(15)*E(18)*E(18))36,38,38
36    WRITE(LI,37)JN(JI)
37    FORMAT(/15X,4H**  ,A4,27H  NON POSITIVE DEFINITE  **/)
38    IF(IN(I+1)-NCS-1)39,41,39
39    NCS=IN(I+1)-1
40    FORMAT(4HAFIX,I3)
      WRITE(LP,40)NCS
      NCS=NCS-MAX0(MOD(NCS,10)-5,0)
41    NR=(IN(I+2)-10)/2
      WRITE(LP,42)JN(JI),NR,(E(J),J=1,NL)
42    FORMAT(A4,I5,6F10.5,2H =/5X,4F10.5)
      IF(IN(10).LT.0)WRITE(LP,43)E(21),E(22),E(23),(E(J+20),J=5,NL)
43    FORMAT(4X,9F8.5)
      GOTO 11
C
C ERROR EXIT
C
44    J=JN(JI)
45    IN(20)=NER
      IN(1)=J
C      WRITE(LB,*)IT,JN,IN,C
      DO 1000 I=1,40
1000  IIT(I)=IT(I)
      DO 1001 I=1,400
1001  JJN(I)=JN(I)
      DO 1002 I=1,1620
1002  IIN(I)=IN(I)
      DO 1003 I=1,4380
1003  CC(I)=C(I)
      GOTO 113
C
46    J=400
      NER=-4
      IF(2000-NH)45,47,47
47    IF(NV)113,53,48
48    NER=-11
      J=MPR
      IF(MPR-NN)45,49,49
49    I=((NN*(NN+3))/2)+10
      IF(MIN0(IN(13),NC-1).LT.1)GOTO 51
      DO 50 J=1,NN
50    ES(J)=D(J)
      GOTO 53
51    DO 52 J=1,I
52    B(J)=0.
53    CALL SFLS
      NV=NV-1
      IF(NV)1,54,54
C
C RETAINED FULL-MATRIX LEAST-SQUARES
C
54    IF(IN(13).LT.0)GOTO 57
      DO 55 J=1,NN
      D(J)=AMAX1(B(J)+DA*C(47),0.1*DA)
55    B(J)=SQRT(ES(J)/D(J))
      IF(NC.EQ.1)GOTO 57
      L=NN+1
      DO 56 I=1,NN
      DO 56 J=I,NN
      B(L)=B(L)*B(I)*B(J)
56    L=L+1
      GOTO 68
C
C INVERT MATRIX
C
57    K=0
      J=NN+1
      DO 61 NI=1,NN
      K=K+2
      I=J-1
      M=J+1
      B(J)=1./AMAX1(B(J)+DA*C(47),0.1*DA)
      IF(NI-NN)58,61,61
58    B(K)=-B(J)*B(M)
      M=M+1
      K=K+1
      IF(K-J)58,60,60
59    B(M)=B(J)*B(L)+B(M)
      M=M+1
      L=L+1
      IF(I-L)60,59,59
60    L=J+NI-NN
      J=J+1
      IF(I-L)61,59,59
61    CONTINUE
      NI=NN-1
62    NI=NI-1
      J=K
      M=K+NI-NN
      L=M-1
      I=M+1
      K=I+NI-NN
63    B(I)=0.
      I=I+1
      IF(I-J)63,64,64
64    M=M+1
      B(M)=B(K)*B(J)+B(M)
      I=M
      NK=K+1
      IF(L-NK)66,65,65
65    J=J+1
      I=I+1
      B(I)=B(K)*B(J)+B(I)
      B(M)=B(NK)*B(J)+B(M)
      NK=NK+1
      IF(L-NK)66,65,65
66    B(NK)=B(K)*B(M)+B(NK)
      J=J+1
      K=K+1
      IF(L-K)67,64,64
67    IF(-NI)62,68,68
68    DO 69 I=1,NN
69    B(I)=0.
      L=NN+1
      DO 71 I=1,NN
      B(I)=B(I)-B(L)*A(I)
      T=B(L)*R
      DO 70 K=I,NN
      B(I)=B(L)*A(K)+B(I)
      B(K)=B(L)*A(I)+B(K)
70    L=L+1
71    A(I)=SQRT(ABS(T))
C
C RIGID GROUP SHIFTS
C
      U=B(1)
      B(1)=0.
      NH=1
      K=IN(5)
      I=17
72    I=I+4
      IF(IN(6)-I)79,73,73
73    X=1.
      IF(1-IABS(MOD(IN(I+1),10)-5))74,76,77
74    DO 75 L=1,5
      N=ID(NH)
      E(L)=B(N)*H(NH)
75    NH=NH+1
      NH=NH-5
      GOTO 78
76    X=0.
77    C(K+1)=C(K+1)+E(1)
      C(K+2)=C(K+2)+E(2)
      C(K+3)=C(K+3)+E(3)
      C(K+4)=C(K+4)+E(4)*X
      C(K+5)=C(K+5)+E(5)*X
78    NH=NH+IN(I)
      K=K+IN(I)
      GOTO 72
79    B(1)=U
      IF(NA)87,87,80
80    DO 82 L=1,NA,3
      N=IX(L)
      K=IX(L+2)
      DO 81 J=1,3
      E(J)=SIN(B(N))
      E(J+3)=COS(B(N))-1.
81    N=N+1
      U=DX(L+1)-DX(L)*G(136)
      V=DX(L+2)-DX(L)*G(139)
      Y=U*E(4)+E(1)*(G(127)*U+G(130)*V)+DX(L+1)
      Z=V*E(4)-E(1)*(G(133)*U+G(127)*V)+DX(L+2)
      U=DX(L)-Y*G(140)
      V=Z-Y*G(137)
      X=U*E(5)-E(2)*(G(128)*U+G(134)*V)+DX(L)
      Z=V*E(5)+E(2)*(G(131)*U+G(128)*V)+Z
      C(K+2)=C(K+2)-DX(L+2)+Z
      U=X-Z*G(138)
      V=Y-Z*G(141)
      C(K)=C(K)-DX(L)+U*E(6)+E(3)*(G(129)*U+G(132)*V)+X
82    C(K+1)=C(K+1)-DX(L+1)+V*E(6)-E(3)*(G(135)*U+G(129)*V)+Y
C
C L.S. RESULTS
C
83    FORMAT(//6H CYCLE,I3/39X,17HESD     SHIFT/ESD/)
84    FORMAT(20H   1   OVERALL SCALE,F11.5,F13.5,F10.3)
85    FORMAT(I4,6X,A4,I4,2F13.5,F10.3)
86    FORMAT(I4,6X,2A4,2F13.5,F10.3)
87    N=0
      JI=0
      WRITE(LI,83)NC
      K=IN(4)+1
      ASSIGN 90 TO MC
88    B(N+1)=B(N+1)*C(K)
      A(N+1)=A(N+1)*C(K)
89    N=N+1
      U=AMIN1(A(N),10.)
      C(K)=C(K)+B(N)
      V=B(N)/U
      B(N)=A(N)
      A(N)=AMOD(U,9.99999)
      GOTO MC,(90,94,101)
90    WRITE(LI,84)C(K),A(N),V
      K=IN(3)+6
      NI=IH(13)
      J=1
      ASSIGN 94 TO MC
91    K=K+1
      IF(IN(5)-K)95,92,92
92    IF(K-IN(4)-1)88,93,89
93    NI=IH(14)
      J=2
      K=K+1
      GOTO 91
94    WRITE(LI,85)N,NI,J,C(K),A(N),V
      J=J+1
      GOTO 91
95    ASSIGN 101 TO MC
      NI=0
      I=17
96    I=I+4
      JI=JI+1
      J=0
      IF(IN(6)-I)104,97,97
97    L=16
      IF(MOD(IN(I+1),10).NE.7)GOTO 99
      IF(IN(I+3).EQ.0)GOTO 98
      IF(MOD(IN(I+3)/KB,2).EQ.0)GOTO 99
98    N=N+1
      X=B(N)
      U=AMIN1(A(N),10.)
      V=B(N)/U
      B(N)=A(N)
      A(N)=AMOD(U,9.99999)
      WRITE(LI,86)N,JN(JI),IH(L),X,A(N),V
      L=L+1
      IF(L-19)98,99,99
99    J=J+1
      IF(IN(I)-J)96,100,100
100   NI=NI+1
      IF(ID(NI)-N-1)103,89,103
101   WRITE(LI,86)N,JN(JI),IH(J),C(K),A(N),V
      C(K)=AMAX1(-4.,AMIN1(4.,C(K)))
      IF((4-J)*(J-7))103,102,102
102   C(K)=AMAX1(C(K),0.0001)
103   K=K+1
      GOTO 99
C
C BLOC ESDS
C
104   A(1)=0.
      IF(KH.EQ.0)GOTO 106
      DO 105 I=1,NI
      J=ID(I)
      X=0.
      IF(J.GT.1)X=ABS(A(J)*H(I))
105   IF(X.GT.1.E-6)ES(I)=X
C
C CORRELATION COEFFICIENTS AND RECYCLE
C
C106   WRITE(LB,*)IT,JN,IN,C
106   DO 1004 I=1,40
1004  IIT(I)=IT(I)
      DO 1005 I=1,400
1005  JJN(I)=JN(I)
      DO 1006 I=1,1620
1006  IIN(I)=IN(I)
      DO 1007 I=1,4380
1007  CC(I)=C(I)
      J=0
      E(1)=0.
      L=NN
      DO 109 I=1,NN
      DO 109 K=I,NN
      L=L+1
      IF(I-K)107,109,109
107   V=B(L)*R/(B(I)*B(K))
      IF(ABS(V)-0.5)109,108,108
108   E(J+1)=I
      E(J+2)=K
      J=J+3
      E(J)=V
      IF(299-J)110,109,109
109   CONTINUE
      J=MAX0(J,1)
110   WRITE(LI,111)
111   FORMAT(//45H CORRELATION MATRIX ELEMENTS GREATER THAN 0.5)
      WRITE(LI,112)(E(I),I=1,J)
112   FORMAT(20(/5(2F5.0,F8.4,4X))/5H ETC.)
      GOTO 1
113   RETURN
      END
C
      SUBROUTINE SFLS
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS,
     * NP,KH,NA,NH,R,SF,DA,IT(40),JN(400),IN(1620),C(4380),ID(2000),
     * IX(1200),E(510),A(510),H(2000),D(4000),F(84),DX(1200),G(141),
     * ES(2000),B(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      NE=IN(4)+1
      NR=0
      DA=0.
      RM=0.
      RC=0.
      SA=0.
      SB=0.
      SC=0.
      SD=0.
      SE=0.
      DO 1 J=1,510
      A(J)=0.
1     E(J)=0.
      DO 2 J=26,32
2     C(J)=0.
      DO 3 J=1,4000
3     D(J)=0.
      IF(0.0001-C(46))6,6,34
4     IF(NV)6,5,6
C5     WRITE(LA,*)F
5     ILA=ILA+1
      DO 206 I=1,84
206   EE(ILA,I)=F(I)
C6     READ(LF,*)F
6     ILF=ILF+1
      DO 121 I=1,84
121   F(I)=FF(ILF,I)
      I=1
7     IF(ABS(F(I))-.8)55,8,8
8     IF(C(46)-F(I+3))33,9,9
9     NR=NR+1
C
C SFAC
C
      V=1.266515*C(1)*C(1)*F(I+3)
      U=AMOD(V,2.)
      M=INT(V-U)+2
      U=0.5*U
      NB=12
      NK=IN(2)
      DO 10 J=NS,NK,103
      E(NB+1)=C(J+1)
      K=M+J
      E(NB)=C(K)+U*(C(K+2)-C(K)+C(K+1)-U*C(K+1))
10    NB=NB+2
C
C H K L
C
      CALL HKL(F(I),E(2),E(3),E(4))
      E(1)=0.
      U=0.
      V=0.
      NK=NB
      J=IN(5)
      K=17
11    K=K+4
      J=J+IN(K)
      IF(IN(K)-10)12,13,13
12    E(NK)=EXP(-C(J)*F(I+3))
      NK=NK+1
13    IF(IN(6).GT.K)GOTO 11
      J=61
14    X=E(2)*C(J)+E(3)*C(J+3)+E(4)*C(J+6)
      Y=E(2)*C(J+1)+E(3)*C(J+4)+E(4)*C(J+7)
      Z=E(2)*C(J+2)+E(3)*C(J+5)+E(4)*C(J+8)
      T=E(2)*C(J+9)+E(3)*C(J+10)+E(4)*C(J+11)+100.005
      E(7)=-Y*Y*C(15)
      E(8)=-Z*Z*C(16)
      E(9)=-Y*Z*C(20)
      E(10)=-X*Z*C(21)
      E(11)=-X*Y*C(22)
C
C ATOMS
C
      NK=NB
      NI=17
      K=IN(5)
      N=1
      GOTO 16
15    N=N+IN(NI)
16    NI=NI+4
      IF(NI.GT.IN(6))GOTO 20
      IF(6.GT.IN(NI))GOTO 17
      E(6)=-X*X*C(14)
      P=EXP(E(6)*C(K+5)+E(7)*C(K+6)+E(8)*C(K+7)+E(9)*C(K+8)+
     *E(10)*C(K+9)+E(11)*C(K+10))
      GOTO 18
17    P=E(NK)
      NK=NK+1
      E(6)=-F(I+3)
18    S=AMOD(C(K+1)*X+C(K+2)*Y+C(K+3)*Z+T,1.)
      M=INT(100.*S)
      S=(AMOD(S,0.01)-0.005)*6.282579
      R=1.-.5000612*S*S
      O=R*G(M+1)+S*G(M+26)
      Q=R*G(M+26)-S*G(M+1)
      P=P*C(K+4)*C(25)
      NL=IN(NI+2)
      S=P*E(NL+1)
      R=P*E(NL)
      P=R*Q
      R=R*O
      Q=S*Q
      S=S*O
      U=U+P-S*C(23)
      V=V+R*C(23)+Q
      W=C(K+4)
      K=K+IN(NI)
      IF(IN(NI+3).EQ.2)GOTO 15
C
C DERIVATIVES
C
      P=P-S
      Q=R+Q
      R=P*6.283153
      S=Q*6.283153
      E(5)=1./AMAX1(W,0.0001)
      D(N)=D(N)-S*X
      D(N+2000)=D(N+2000)+R*X
      D(N+1)=D(N+1)-S*Y
      D(N+2001)=D(N+2001)+R*Y
      D(N+2)=D(N+2)-S*Z
      D(N+2002)=D(N+2002)+R*Z
      N=N+3
      L=IN(NI)+1
      DO 19 M=5,L
      D(N)=D(N)+E(M)*P
      D(N+2000)=D(N+2000)+E(M)*Q
19    N=N+1
      GOTO 16
20    J=J+12
      IF(IN(1)-J)21,14,14
C
C F CALC AND F OBS
C
21    L=MIN0(5,1+IABS(IN(12)))
      E(5)=INT(0.001*F(I+4))
      M=INT(ABS(E(L))+1.1)
      L=MIN0(IN(4),M+IN(3)+5)
      X=U*U+V*V
      O=1./AMAX1(AMOD(C(NE),100.)*AMOD(C(L),100.),1.E-6)
      F(I+1)=F(I+1)*O
      W=F(I+2)*O*O
      O=F(I+1)*F(I+1)
      F(I+2)=ABS(C(59)/(W+O*ABS(C(60))))
      IF(C(60).GT.9.E8)F(I+2)=1.
      J=IN(4)+IN(19)+1
      T=1.
      IF(IN(19).GT.1)T=EXP(F(I+5)*(C(J)-1.))
      CR=F(I+5)
      P=0.
      J=IN(8)+IN(4)+1
      IF(IN(8).GT.1)P=X/(C(1)*SQRT(F(I+3))*1125.395)
      Q=(1.-C(J)*P)*T
      F(I+4)=U*Q
      F(I+5)=V*Q
      S=SQRT(X)
      X=S*Q
      Y=F(I+1)-X
      SA=SA+W*W
      SB=SB+W*O
      SC=SC+O*O
      SD=SD+Y*Y*W
      SE=SE+Y*Y*O
      DA=DA+F(I+2)
      W=SQRT(F(I+2))
      C(26)=AMAX1(C(26),F(I+1))
      C(27)=C(27)+ABS(Y)
      C(28)=C(28)+F(I+1)
      C(29)=C(29)+W*ABS(Y)
      C(30)=C(30)+W*F(I+1)
      C(31)=C(31)+F(I+2)*Y*Y
      C(32)=C(32)+F(I+2)*O
      RM=RM+F(I+2)*F(I+1)*X
      RC=RC+F(I+2)*X*X
      IF(NV)33,33,22
C
C ADD DERIVATIVES
C
22    NB=NN+10
      Q=T*(1.-3.*C(J)*P)*W/AMAX1(S,1.E-6)
      DO 23 J=1,NB
23    E(J)=0.
      X=X*W
      U=U*Q
      V=V*Q
      J=IN(8)+NP+1
      IF (IN(8).GT.1) E(J)=-P*S*T*W
      J=IN(19)+NP+1
      IF (IN(19).GT.1) E(J)=CR*X
      O=1.99-0.01*C(L)
      E(M)=X*AINT(O)
      N=N-1
      IF(NA)26,26,24
24    DO 25 NB=1,NA,3
      NM=IX(NB)
      J=IX(NB+1)
      O=U*D(J)+V*D(J+2000)
      P=U*D(J+1)+V*D(J+2001)
      Q=U*D(J+2)+V*D(J+2002)
      T=(DX(NB+1)-DX(NB)*G(136))*(P*G(127)-Q*G(133))
      E(NM)=T+E(NM)+(DX(NB+2)-DX(NB)*G(139))*(P*G(130)-Q*G(127))
      T=(DX(NB)-DX(NB+1)*G(140))*(Q*G(131)-O*G(128))
      E(NM+1)=E(NM+1)+T+(DX(NB+2)-DX(NB+1)*G(137))*(Q*G(128)-O*G(134))
      T=(DX(NB)-DX(NB+2)*G(138))*(O*G(129)-P*G(135))
25    E(NM+2)=E(NM+2)+T+(DX(NB+1)-DX(NB+2)*G(141))*(O*G(132)-P*G(129))
26    DO 27 J=1,N
      K=ID(J)
      E(K)=E(K)+H(J)*(U*D(J)+V*D(J+2000))
      D(J)=0.
27    D(J+2000)=0.
      ASSIGN 33 TO NU
      E(1)=SF*X
      W=W*Y
28    M=NN+1
      ASSIGN 30 TO KQ
      IF(MIN0(IN(13),NC-1).GT.0)ASSIGN 32 TO KQ
      DO 32 N=1,NN
      Y=E(N)
      L=M
      M=M+NN-N+1
      IF(Y)29,32,29
29    A(N)=W*Y+A(N)
      B(N)=B(N)+Y*Y
      GOTO KQ,(30,32)
30    K=N
31    B(L)=Y*E(K)+B(L)
      B(L+1)=Y*E(K+1)+B(L+1)
      B(L+2)=Y*E(K+2)+B(L+2)
      B(L+3)=Y*E(K+3)+B(L+3)
      B(L+4)=Y*E(K+4)+B(L+4)
      B(L+5)=Y*E(K+5)+B(L+5)
      B(L+6)=Y*E(K+6)+B(L+6)
      B(L+7)=Y*E(K+7)+B(L+7)
      B(L+8)=Y*E(K+8)+B(L+8)
      B(L+9)=Y*E(K+9)+B(L+9)
      L=L+10
      K=K+10
      IF(NN.GT.K)GOTO 31
      B(L)=Y*E(K)+B(L)
32    CONTINUE
      GOTO NU,(33,40,49)
33    I=I+6
      IF(LV-I)4,7,7
C
C BOND LENGTH CONSTRAINTS
C
34    S=0.
      R=1.E-7
      DA=1.
35    WRITE(LI,36)NC
      WRITE(LI,37)
36    FORMAT(///38H CONSTRAINED BOND LENGTHS BEFORE CYCLE,I3/)
37    FORMAT(15X,3HOBS,5X,16HOBS-FIX    SIGMA)
38    FORMAT(/1X,A4,1H-,A4,3F10.4)
      NH=1
      L=IN(6)
      DO 39 I=21,L,4
      IN(I+1)=NH+IN(5)
      IN(I+2)=NH
39    NH=NH+IN(I)
      I=IN(7)
      ASSIGN 40 TO NU
40    IF(C(I)-0.001)47,41,41
41    W=SQRT(R)/C(I+1)
      X=1.
      DO 42 J=1,NN
42    E(J)=0.
      L=MAX0(INT(0.1*C(I)),1)
      Q=C(I)
      IF(L-1)45,45,43
43    M=L+IN(4)+1
      Q=AMOD(C(M),10.)*AMOD(C(I),10.)
      IF(C(M)-10.)44,45,45
44    K=L+NP+1
      E(K)=W*AMOD(C(I),10.)
45    K=C(I+2)
      M=C(I+3)
      NI=IN(K+2)
      NK=IN(K+1)
      NT=IN(M+2)
      NZ=IN(M+1)
      X=C(NK)-C(NZ)
      Y=C(NK+1)-C(NZ+1)
      Z=C(NK+2)-C(NZ+2)
      P=X*X*C(8)+Y*Y*C(9)+Z*Z*C(10)+Y*Z*C(11)+X*Z*C(12)+X*Y*C(13)
      P=SQRT(ABS(P))
      C(14)=C(8)*X+0.5*(C(12)*Z+C(13)*Y)
      C(15)=C(9)*Y+0.5*(C(11)*Z+C(13)*X)
      C(16)=C(10)*Z+0.5*(C(11)*Y+C(12)*X)
      DO 46 J=14,16
      N=ID(NI)
      E(N)=E(N)-H(NI)*C(J)*W/P
      N=ID(NT)
      E(N)=E(N)+H(NT)*C(J)*W/P
      NI=NI+1
46    NT=NT+1
      E(1)=0.
      O=P-Q
      W=W*O
      J=(K-17)/4
      N=(M-17)/4
      WRITE(LI,38)JN(J),JN(N),P,O,C(I+1)
      I=I+4
      IF(NV)40,40,28
47    U=0.
      V=100000.
      IF(0.0001-C(46))57,57,65
C
C ILSF/U(JJ) CONSTRAINTS
C
48    ASSIGN 49 TO NU
      NI=17
      T=1.E3*SQRT(R)
      NH=5
      IF(IN(12)+4)56,56,50
49    NH=NH+IN(NI)
50    NI=NI+4
      IF(IN(6)-NI)56,51,51
51    IF(IN(NI)-6)49,52,52
52    DO 53 K=1,NN
53    E(K)=0.
      K=NH+2
      DO 54 L=NH,K
      N=ID(L)
54    E(N)=H(L)*T
      NK=NH-IN(12)-1
      N=ID(NK)
      E(N)=E(N)-3.*H(NK)*T
      NK=NK+IN(5)
      I=NH+IN(5)
      W=T*(3.*C(NK)-C(I)-C(I+1)-C(I+2))
      E(1)=0.
      GOTO 28
C
C RESIDUALS
C
55    S=1.
      R=C(31)/FLOAT(NR-NN)
      GOOF=SQRT(R)
      IF(1.GT.NV)GOTO 56
      IF(IN(12))48,56,56
56    IF(IN(7))57,57,35
57    IF(NV)59,58,59
C58    WRITE(LA,*)F
58    ILA=ILA+1
      DO 207 I=1,84
207   EE(ILA,I)=F(I)
C      ENDFILE LA
C      REWIND LA
      ILA=0
C59    REWIND LF
59    ILF=0
60    FORMAT(///23H RESIDUALS BEFORE CYCLE,I4,5H FOR ,40A1/)
61    FORMAT(4H R =,F8.4,5X,4HRW =,F8.4,5X,4HRG =,F8.4,5X,4HRM =,F8.4/)
62    FORMAT(4H N =,I5,5X,4HNP =,I4,5X,9HMAX(NP) =,I4,5X,
     +6HGOOF =,F8.4/)
63    FORMAT(9H WEIGHT =,F10.4,18H / ( SIGMA**2(F) +,F9.6,6H F*F ))
      R=R*S
      U=C(27)/C(28)
      V=C(29)/C(30)
      W=SQRT(C(31)/C(32))
      RM=SQRT(1.-(RM*RM/(C(32)*RC)))
      WRITE(LI,60)NC,IT
      WRITE(LI,61)U,V,W,RM
      WRITE(LI,60)NC,IT
      PRINT 61,U,V,W,RM
      W=ABS(C(60))
      IF(W.LT.9.E8)WRITE(LI,63)C(59),W
      IF(W.GT.9.E8)WRITE(LI,64)
64    FORMAT(13H UNIT WEIGHTS)
      W=SD*SC-SB*SE
      U=W/(SA*SC-SB*SB)
      W=(SB*SD-SA*SE)/W
      V=C(26)
      IF(U.GT.0.)GOTO 65
      U=1.
      W=(SB-SE)/SC
C65    READ(LB,*)IT,JN,IN,C
65    DO 1010 I=1,40
1010  IT(I)=IIT(I)
      DO 1011 I=1,400
1011  JN(I)=JJN(I)
      DO 1012 I=1,1620
1012  IN(I)=IIN(I)
      DO 1013 I=1,4380
1013  C(I)=CC(I)
      IF(KH.GT.0)IN(13)=-IABS(IN(13))
      C(59)=U
      IF(C(60).GT.-1.E-10)GOTO 66
      C(60)=AMIN1(-9.E-9,W)
66    C(26)=V
      C(27)=FLOAT(NR)/DA
      C(29)=R
      C(59)=1.
      RETURN
      END
C
      SUBROUTINE ABOND
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS,
     * NP,KH,NA,NH,R,SF,DA,IT(40),JN(400),IN(1620),C(4380),ID(2000),
     * IX(1200),E(510),A(510),H(2000),D(4000),F(84),DX(1200),G(141),
     * ES(2000),B(100)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
1     FORMAT(/1X,A4,7H  X/A =,F7.4,7H  Y/B =,F7.4,7H  Z/C =,F7.4)
2     FORMAT(1H ,A4,3H---,A4,F8.3,2H (,F6.3,2H ),I3,3(1H,,F8.4))
3     FORMAT(1H ,A4,1H-,A4,1H-,A4,F7.1,2H (,F4.1,2H ))
4     FORMAT(1H ,A4,3H...,A4,F8.3,10X,I3,3(1H,,F8.4))
C      WRITE(LB,*)IT,JN,IN,C
      DO 1000 I=1,40
1000  IIT(I)=IT(I)
      DO 1001 I=1,400
1001  JJN(I)=JN(I)
      DO 1002 I=1,1620
1002  IIN(I)=IN(I)
      DO 1003 I=1,4380
1003  CC(I)=C(I)
      IF(MIN0(IN(20),INT(C(48)+99.),IN(6)-20))69,5,5
5     ND=IN(5)
      NY=IN(6)
      NP=IN(1)
      NF=(INT(1.1-C(23))*3)+13
      C(49)=AMAX1(C(48),C(49))
      WRITE(LI,6)IT
6     FORMAT(///40A1)
      J=NN+NN
      K=NN+1
      DO 7 I=K,J
7     B(I)=0.
      IF(KH.EQ.0)GOTO 9
      DO 8 I=1,2000
8     ID(I)=I
C
C LATTICE
C
9     DO 10 J=1,12
10    G(J)=10.0001
      DO 11 J=4,11
11    G(J)=10.5001
      NS=1
      N=IN(18)
      IF(N-1)12,18,12
12    NS=4
      G(N-1)=10.0001
      IF(N-3)18,13,13
13    IF(N-4)14,17,18
14    NS=7
      DO 15 J=4,9
15    G(J)=10.66677
      DO 16 J=5,7
16    G(J)=10.33343
      GOTO 18
17    NS=10
      G(4)=10.0001
      G(8)=10.0001
18    NZ=IN(2)
      I=19
      NB=IN(1)+12
      DO 19 NI=NB,NZ,103
      DX(I)=C(NI)+0.5*C(48)
      DX(I+1)=C(NI)+0.5*C(49)
19    I=I+2
      I=0
      JA=0
      DO 68 NI=21,NY,4
      JI=IN(NI+2)
      JA=JA+1
      NZ=-2
      MM=6
      NC=0
C
C EQUIVALENT POSITIONS
C
      DO 67 M=1,NS,3
      DO 67 N=61,NP,12
      LY=(N-49)/12
      NB=I+ND
      J=M
      K=N
      NE=N+9
      DO 20 NR=4,6
      DX(NR)=C(NB+1)*C(K)+C(NB+2)*C(K+1)+C(NB+3)*C(K+2)+C(NE)
      DX(NR+9)=DX(NR)+G(J)
      DX(NR+12)=20.0002-DX(NR+9)
      NE=NE+1
      J=J+1
20    K=K+3
      CS=1.
      DO 67 NCS=13,NF,3
      G(NC+13)=AMOD(DX(NCS),1.)-.000099
      G(NC+14)=AMOD(DX(NCS+1),1.)-.000099
      G(NC+15)=AMOD(DX(NCS+2),1.)-.000099
      K=0
21    IF(K-NC)22,24,24
22    S=ABS(G(K+13)-G(NC+13))+ABS(G(K+14)-G(NC+14))
      IF(0.01-ABS(G(K+15)-G(NC+15))-S)23,66,66
23    K=K+3
      GOTO 21
24    WRITE(LI,1)JN(JA),G(NC+13),G(NC+14),G(NC+15)
      NC=NC+3
      J=0
      NV=1
      JB=0
      DO 65 NJ=21,NY,4
      JB=JB+1
      LJ=NCS
      NE=J+ND
      DO 25 NR=1,3
      NE=NE+1
      X=DX(LJ)-C(NE)-0.0001
      DX(NR)=X-AINT(X+SIGN(0.5,.000001+X))
      DX(NR+6)=0.00001+DX(NR)-DX(NR+3)*CS+C(NE)
25    LJ=LJ+1
      X=DX(1)
      Y=DX(2)
      Z=DX(3)
      NE=6
      LJ=IN(NJ+2)
      ASSIGN 27 TO NA
C
C BOND LENGTHS
C
26    Q=C(8)*X*X+C(9)*Y*Y+C(10)*Z*Z+C(11)*Y*Z+C(12)*X*Z+C(13)*X*Y
      GOTO NA,(27,32,62)
27    P=SQRT(Q)
      IF(DX(JI+8)+DX(LJ+8)-P)65,28,28
28    IF(Q-0.1)65,29,29
29    IF(3-NC)56,30,30
30    IF(DX(JI+7)+DX(LJ+7)-P)56,31,31
31    NG=J
32    NT=NZ+3
      A(NT+4)=0.5*(C(12)*Z+C(13)*Y)+C(8)*X
      A(NT+5)=0.5*(C(11)*Z+C(13)*X)+C(9)*Y
      A(NT+6)=0.5*(C(11)*Y+C(12)*X)+C(10)*Z
      IF(I-J)33,60,33
33    IF(6-NE)52,34,34
34    E(NT+3)=P
      IT(NV)=J
      IT(NV+20)=JB
      DO 35 NR=1,3
      NT=NT+1
      NU=I+NR
      NG=NG+1
      E(NT+3)=DX(NR)
      A(NT+6)=A(NT+3)*H(NU)/P
      A(NT+3)=-A(NT+3)*H(NG)/P
      IX(NT+6)=ID(NU)
35    IX(NT+3)=ID(NG)
      NZ=NT
      NV=NV+1
      DD=1.
      ASSIGN 43 TO NA
      IF(NV-13)38,38,36
36    WRITE(LI,37)JN(JA)
37    FORMAT(//22H ** TOO MANY BONDS TO ,A4)
      GOTO 68
C
C COVARIANCE MATRIX
C
38    S=0.
      IF(IN(13).EQ.0)GOTO 42
      IF(IN(13).LT.-998)GOTO 42
      DO 41 NM=1,NE
      NG=NM+NZ
      NB=NM+NT
      IF(KH.EQ.0)GOTO 39
      NU=IX(NG)
      O=A(NB)*ES(NU)
      S=S+O*O
      GOTO 41
39    O=C(29)
      DO 40 NO=NM,NE
      NQ=NO+NZ
      NR=NO+NT
      NU=MIN0(IX(NQ),IX(NG))
      NU=(NN+NN-NU-1)*NU/2
      NU=NU+IX(NQ)+IX(NG)
      S=S+A(NR)*A(NB)*B(NU)*O
40    O=C(29)+C(29)
41    CONTINUE
      S=SQRT(ABS(S))
42    GOTO NA,(43,54)
43    K=-2
      NH=0
      IF(DX(JI+7)+DX(LJ+7)-P)44,46,46
44    WRITE(LI,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)
      IF(IN(10))45,49,49
45    WRITE(LP,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)
      GOTO 49
46    S=AMIN1(S,9.999)
      WRITE(LI,2)JN(JB),JN(JA),P,S,LY,DX(7),DX(8),DX(9)
      IF(IN(10))47,49,49
47    IF(I-J)48,48,49
48    WRITE(LP,2)JN(JB),JN(JA),P,S,LY,DX(7),DX(8),DX(9)
49    K=K+6
      NH=NH+1
      IF(K-NZ)50,65,65
50    X=E(K+1)-DX(1)*DD
      Y=E(K+2)-DX(2)*DD
      Z=E(K+3)-DX(3)*DD
      ASSIGN 62 TO NA
      IF(I-J)51,26,51
51    ASSIGN 32 TO NA
      NE=9
      NG=IT(NH)
      GOTO 26
C
C ANGLE ABC
C
52    O=P*P
      T=E(K)*E(K)
      S=0.5/(P*E(K))
      Z=S*(O+T-Q)
      X=S*(T-O-Q)/P
      Y=S*(O-T-Q)/E(K)
      T=S+S
      DO 53 NM=1,3
      NG=NM+NZ
      NB=NM+NT
      NQ=NM+K
      NU=J+NM
      NO=IT(NH)+NM
      A(NB+6)=A(NG)*X+T*A(NB+3)*H(NU)
      A(NB+9)=A(NQ+3)*Y+A(NG+3)*X
      A(NB+12)=A(NQ)*Y-T*A(NB+3)*H(NO)
53    IX(NG+6)=IX(NQ)
      T=SQRT(ABS(1.-Z*Z))
      Z=ATAN2(T,Z)
      NT=NT+6
      NX=IT(NH+20)
      NW=JA
      ASSIGN 54 TO NA
      GOTO 38
54    S=S*57.29578/AMAX1(T,0.01)
      Z=Z*57.29578
      Z=AMOD(Z+720.,360.)
      S=AMIN1(S,99.9)
      WRITE(LI,3)JN(JB),JN(NW),JN(NX),Z,S
      IF(IN(10))55,49,49
55    WRITE(LP,3)JN(JB),JN(NW),JN(NX),Z,S
      GOTO 49
56    IF(I-J)57,32,59
57    IF(IN(10))58,59,59
58    WRITE(LP,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)
59    WRITE(LI,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)
      GOTO 65
C
C BOND A-A*
C
60    DO 61 K=1,3
      NB=NT+K
      NM=N+K-1
      NQ=I+K
      A(NB)=A(NT+4)*C(NM)+A(NT+5)*C(NM+3)+A(NT+6)*C(NM+6)
      A(NB)=H(NQ)*(A(NB)*CS-A(NB+3))/P
      NG=NZ+K
61    IX(NG)=ID(NQ)
      NE=3
      DD=-1.
      ASSIGN 43 TO NA
      GOTO 38
C
C ANGLE ABA*
C
62    X=0.5/Q
      Q=SQRT(Q)
      T=ABS(Q-E(K))
      IF(T-0.01)63,49,49
63    Q=0.5*(Q+E(K))
      DO 64 NM=1,3
      NB=NM+NT
      NQ=K+NM
      A(NB+3)=X*(A(NB)*Q-A(NQ+3)*P)
      A(NB+6)=-X*A(NQ)*P
      NG=NZ+NM
64    IX(NG+3)=IX(NQ)
      NE=6
      NT=NT+3
      NX=JA
      NW=IT(NH+20)
      Z=0.5*P/Q
      T=SQRT(ABS(1.-Z*Z))
      Z=ATAN2(Z,T)*2.
      T=T*0.5
      ASSIGN 54 TO NA
      GOTO 38
65    J=J+IN(NJ)
66    NZ=NZ+MM
      MM=0
      LY=-LY
67    CS=-1.
68    I=I+IN(NI)
69    RETURN
      END
C
      SUBROUTINE XMAP
      DIMENSION ID(29)
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,JN(400),
     *IT(40),C(4380),IN(3334),G(126),F(84),IL(30),IM(28),E(4452),A(1)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      DATA IX/1HX/,IY/1HY/,IZ/1HZ/
      DATA ID(1)/4H  PA/,ID(2)/4H DIF/,ID(3)/4H    /,ID(4)/4H    /
      DATA ID(5)/4H  WT/,ID(6)/4H  E*/,ID(7)/4HTTER/,ID(8)/4HFERE/
      DATA ID(9)/4HFOUR/,ID(10)/4H    /,ID(11)/4H. DI/,ID(12)/4HF PA/
      DATA ID(13)/4HSON /,ID(14)/4HNCE /,ID(15)/4HIER /,ID(16)/4H  E-/
      DATA ID(17)/4HFF. /,ID(18)/4HTT. /
      DATA ID(19)/1H /,ID(20)/1H0/,ID(21)/1H1/,ID(22)/1H2/,ID(23)/1H3/
      DATA ID(24)/1H4/,ID(25)/1H5/,ID(26)/1H6/,ID(27)/1H7/,ID(28)/1H8/
      DATA ID(29)/1H9/
C      READ(LB,*)IT,JN,(IN(I),I=1,1620),C
      DO 1000 I=1,40
1000  IT(I)=IIT(I)
      DO 1001 I=1,400
1001  JN(I)=JJN(I)
      DO 1002 I=1,1620
1002  IN(I)=IIN(I)
      DO 1003 I=1,4380
1003  C(I)=CC(I)
      IF(IN(20))97,1,1
1     MDM=LM-LV-12795+(1795*LU)
      Y=0.
      DO 2 I=1,126
      G(I)=SIN(Y)
2     Y=Y+6.283185E-2
      I=IN(4)+1
      OS=1.
      IF(I.GT.1)OS=AMOD(C(I),100.)
      WW=0.
      IF(0.001.LT.ABS(C(24)))WW=SIGN(.0087788/(C(24)*C(24)),C(24))
      MP=MIN0(4321,(4*IABS(IN(17)))+1597)
      KF=IN(9)+9998
      NP=0
      NX=IN(16)
      JJ=IN(14)
      JP=MIN0(KF,IN(17))
      NV=1
      NS=IN(1)
      JF=IABS(IN(14))/7
      NZ=MIN0(IABS(IN(14))-3*JF,6)
      MA=MAX0(MIN0(IABS(IN(15)),3),1)
      MB=IN(15)
      NI=LF
      NA=1
      MM=1
      DO 3 I=1,MA
      J=IX
      IX=IY
      IY=IZ
3     IZ=J
      IF(MB)5,4,4
4     J=IX
      IX=IY
      IY=J
5     DO 6 I=1,3334
6     IN(I)=0
C
C READ REFLEXIONS
C
      ASSIGN 9 TO NF
      ASSIGN 21 TO NG
      ASSIGN 36 TO NU
      IF((NZ-1)*(6-NZ))92,8,7
7     NI=LA
C8     READ(NI,*)F
8     IF(NI.EQ.LF)GO TO 130
      IF(NI.EQ.LC)GO TO 140
C  IF not LF or LC then should be LA
      ILA=ILA+1
      DO 208 I=1,84
208   F(I)=EE(ILA,I)
      GO TO 131
140   ILC=ILC+1
      DO 141 I=1,84
141   F(I)=FC(ILC,I)
      GO TO 131
130   ILF=ILF+1
      DO 121 I=1,84
121   F(I)=FF(ILF,I)
131   CONTINUE
      I=-5
      IF(F(1)+9.E9)96,9,9
9     I=I+6
      IF(LV-I)8,10,10
10    IF(ABS(F(I))-0.8)35,11,11
11    IF(C(46)-F(I+3))9,12,12
12    CALL HKL(F(I),X,Y,Z)
      S=F(I+4)*F(I+4)+F(I+5)*F(I+5)
      IF(F(I+2))9,9,13
13    IF(1.E-10-S)14,9,9
14    U=SQRT(S)
      V=F(I+1)-U
      SE=0.
      KJ=NA-4
C
C LOCATING SCHEME
C
      DO 23 K=61,NS,12
      P=X*C(K)+Y*C(K+3)+Z*C(K+6)
      Q=X*C(K+1)+Y*C(K+4)+Z*C(K+7)
      R=X*C(K+2)+Y*C(K+5)+Z*C(K+8)
      W=P+100.*(Q+100.*R)
      E(KJ+7)=ABS(W)
      J=NA-4
15    J=J+4
      IF(J-KJ)16,16,17
16    IF(0.5-ABS(E(J+3)-E(KJ+7)))15,15,23
17    DO 18 J=1,MA
      E(KJ+4)=P
      P=Q
      Q=R
18    R=E(KJ+4)
      IF(MB)20,19,19
19    T=P
      P=Q
      Q=T
20    IF(AMAX1(ABS(P),ABS(Q)).GT.33.5)GOTO 23
      T=100.*P+Q
      M=INT(ABS(T)+1.1)
      KJ=KJ+4
      E(KJ+1)=T
      GOTO NG,(21,22)
21    IN(M)=1
      GOTO 23
C
C FOURIER TYPE
C
22    SE=SE+SIGN(0.5,0.5-ABS(F(I)-W))+0.5
      E(KJ+2)=100.*(X*C(K+9)+Y*C(K+10)+Z*C(K+11))
23    CONTINUE
      GOTO NF,(9,24)
24    P=F(I+1)*OS
      W=EXP(-WW*F(I+3))
      GOTO(26,28,27,29,27,25),NZ
25    P=SQRT(SE)*AMOD(F(I+4),10.)
26    Q=0.
      P=F(I+1)*P
      R=10000.5
      GOTO 30
27    Y=F(I+3)*C(1)*C(1)*.6332574
      K=Y
      Y=AMOD(Y,1.)
      Y=P*U*(Y*(C(K+4331)-C(K+4330))+C(K+4330))
      V=P*AMIN1(Y*(.5658+Y*(Y*.0106-.1304)),Y/(Y+.56))
      IF(NZ.EQ.5)V=V-U
28    V=V/U
      P=F(I+4)*V
      Q=F(I+5)*V*C(23)
      GOTO 30
29    F(I+2)=F(I+2)*SQRT(SE)
      P=F(I+4)*F(I+2)
      Q=F(I+5)*F(I+2)
30    P=P*W
      Q=Q*W
      IF(NA.GT.KJ)GOTO 9
      DO 34 K=NA,KJ,4
      Y=SIGN(1.,E(K+1)+0.1)
      X=Y*E(K)
      Z=ABS(E(K+1))+1.1
      M=Z
      N=IN(M)
      A(N)=Z-1.099
C
C HX SUMS
C
      IF((NZ-1)*(6-NZ))32,32,31
31    R=10000.5-Y*E(K+2)
32    S=AMOD(R-ZZ*X,100.)
      M=S
      S=.0628258*(AMOD(S,1.)-0.5)
      T=1.-.5000612*S*S
      O=T*G(M+1)+S*G(M+26)
      S=T*G(M+26)-S*G(M+1)
      Z=Q*Y
      T=P*S-Z*O
      S=-Z*S-P*O
      L=INT(AMOD(10000.5+X*C(36),100.))
      M=N+1
      DO 33 N=3,NH,2
      A(M)=A(M)+T
      A(M+1)=A(M+1)+S
      O=T*G(L+26)-S*G(L+1)
      S=T*G(L+1)+S*G(L+26)
      T=O
33    M=M+2
34    SS=SS+SQRT(P*P+Q*Q)
      GOTO 9
C
C SET UP FOURIER
C
35    GOTO NU,(36,48)
36    M=0
      DO 37 I=1,3334
37    M=M+IN(I)
      N=MIN0(NX,((MDM/(M+2))-1)/2)
      IF(N)95,95,38
38    NH=N+N+1
      NL=(NH*M)+1
      M=1-NH
      DO 39 I=1,3334
      M=M+(NH*IN(I))
39    IN(I)=M
      L=INT(C(34)+1000.1)
      K=INT(C(37)*1.001)
      DO 40 I=1,28
      IM(I)=MOD(L,100)
40    L=L+K
C      REWIND NI
      IF(NI.EQ.LA)ILA=0
      IF(NI.EQ.LF)ILF=0
      IF(NI.EQ.LC)ILC=0
      IF(JF)45,45,41
C41    READ(LA,*)F
41    ILA=ILA+1
      DO 209 I=1,84
209   F(I)=EE(ILA,I)
      IF(F(1)+9.E9)96,42,42
C42    WRITE(LC,*)F
42    ILC=ILC+1
      DO 2000 I=1,84
2000  FC(ILC,I)=F(I)
      DO 43 I=1,LV,6
      IF(0.8.GT.ABS(F(I)))GOTO 44
43    CONTINUE
      GOTO 41
44    NI=LC
C      ENDFILE NI
C      REWIND NI
      ILC=0
45    NC=-1
      NB=-1
      NA=1
      NT=0
      EZ=9999.
      ZZ=C(33)
      YM=AMOD(C(34)+1000.1,100.)-0.1
      ZM=AMOD(C(35)+1000.1,100.)-0.1
      NP=1597
      C(MP)=0.
      C(1597)=999999.
46    SS=0.
      DO 47 I=1,MDM
47    A(I)=0.
      A(NL)=1000000.
      ASSIGN 22 TO NG
      ASSIGN 24 TO NF
      ASSIGN 48 TO NU
      GOTO 8
C
C FOURIER SUMMATIONS
C
48    SS=999.1/SS
      SC=2.221441*SS*C(2)*C(3)*SIN(.0174533*C(7))/SQRT(C(16))
      NV=NV+1
      MS=2
49    Z=0.
      W=50.
      NK=NA+1483
      DO 50 J=NA,NK
50    E(J)=0.
      DO 51 J=1,56
51    F(J)=0.
      NK=MS
      DO 58 I=1,NL,NH
      IF(A(I)-W)56,52,52
52    Q=AMOD(Z*C(38),100.)
      K=Q
      Q=AMOD(Z*ZM,100.)
      L=Q
      N=NA
      DO 54 J=1,53
      L=MOD(L,100)
      W=G(L+1)
      Z=G(L+26)
      DO 53 M=1,25,4
      E(N)=E(N)+F(M)*Z+F(M+28)*W
      E(N+1)=E(N+1)+F(M+1)*Z+F(M+29)*W
      E(N+2)=E(N+2)+F(M+2)*Z+F(M+30)*W
      E(N+3)=E(N+3)+F(M+3)*Z+F(M+31)*W
53    N=N+4
54    L=L+K
      Z=AINT(0.01*A(I)+0.5)+0.0001
      W=100.*Z+50.
      DO 55 J=1,28
      F(J)=0.
55    F(J+28)=0.
56    Q=AMOD(A(I)*C(37),100.)
      K=Q
      Q=AMOD(A(I)*YM,100.)
      L=Q
      U=A(NK)*SS
      V=A(NK+1)*SS
      DO 57 J=1,28
      L=MOD(L,100)
      F(J)=F(J)+U*G(L+26)-V*G(L+1)
      F(J+28)=F(J+28)-V*G(L+26)-U*G(L+1)
57    L=L+K
58    NK=NK+NH
C
C LOCATE MAXIMA
C
      IF(NC)76,59,59
59    Z=C(35)
      DO 69 I=28,1428,28
      Z=Z+C(38)
      Y=C(34)
      DO 69 K=1,26
      Y=Y+C(37)
      NK=I+K
      M=NK+NB
      EZ=AMIN1(EZ,E(M))
      IF(E(M)-0.8*C(MP))69,69,60
60    L=NK+NC
      N=NK+NA
      W=AMAX1(E(L),E(M),E(N),E(M-1),E(M+1),E(M-28),E(M+28))
      Q=AMAX1(W,E(N+1),E(N-1),E(L+1),E(L-1),E(M-27),E(M-29))
      W=AMAX1(Q,E(M+27),E(M+29),E(L+28),E(L-28),E(N+28),E(N-28))
      IF(E(M)-W+0.01)69,61,61
61    Q=E(M)+E(M)
      U=E(L)-E(N)
      V=E(M-1)-E(M+1)
      W=E(M-28)-E(M+28)
      R=U/(E(N)+E(L)-Q)
      S=V/(E(M-1)+E(M+1)-Q)
      T=W/(E(M-28)+E(M+28)-Q)
      Q=E(M)-(U*R+V*S+W*T)*.0416667
      J=NP+4
      NK=J
62    J=J-4
      IF(C(J)-Q)62,63,63
63    NK=NK-4
      IF(J-NK)64,65,65
64    C(NK+4)=C(NK)
      C(NK+5)=C(NK+1)
      C(NK+6)=C(NK+2)
      C(NK+7)=C(NK+3)
      GOTO 63
65    C(J+4)=Q
      C(J+7)=0.01*ZZ+C(36)*(0.005*R-0.01)
      C(J+6)=0.005*(Y+Y+C(37)*S)
      C(J+5)=0.005*(Z+Z+C(38)*T)
      E(M)=E(M)+0.02
      NP=MIN0(NP+4,MP)
      IF(MB)67,66,66
66    T=C(J+5)
      C(J+5)=C(J+6)
      C(J+6)=T
67    DO 68 NK=1,MA
      T=C(J+7)
      C(J+7)=C(J+6)
      C(J+6)=C(J+5)
68    C(J+5)=T
69    CONTINUE
C
C OUTPUT FOURIER
C
70    FORMAT(1H1,3A4,3HMAP,I3,6H  FOR ,40A1//)
71    FORMAT(1X,A1,2H =,F5.2,5X,A1,7H ACROSS,5X,A1,5H DOWN/)
72    FORMAT(14H MULTIPLIED BY,F11.4,10X,5H(SCAN,I3,1H)//)
73    FORMAT(4H0   ,28I4)
74    FORMAT(3H0  ,28(4H*  *),3H* *)
75    FORMAT(1H0,I2,1H*,28I4,2H *,I2)
76    Z=0.01*ZZ
      IF(JJ)77,80,80
77    WRITE(LI,70)ID(NZ),ID(NZ+6),ID(NZ+12),MM,IT
      WRITE(LI,71)IZ,Z,IY,IX
      WRITE(LI,72)SC,NV
      WRITE(LI,73)IM
      WRITE(LI,74)
      M=NA
      L=INT(C(35)+1000.1)
      K=INT(C(38)*1.001)
      DO 79 J=1,53
      IL(1)=MOD(L,100)
      IL(30)=IL(1)
      L=L+K
      DO 78 I=2,29
      IL(I)=E(M)
78    M=M+1
79    WRITE(LI,75)IL
      WRITE(LI,74)
      WRITE(LI,73)IM
80    NC=NB
      NB=NA
      NA=MOD(NA+1484,4452)
      MS=MS+2
      NT=NT+1
      ZZ=ZZ+C(36)
      IF(NX-NT)83,83,81
81    IF(NH-MS)82,49,49
C82    REWIND NI
82    IF(NI.EQ.LC)ILC=0
      IF(NI.EQ.LA)ILA=0
      IF(NI.EQ.LF)ILF=0
      GOTO 46
83    IF(NP-1600)94,84,84
84    WRITE(LI,70)ID(NZ),ID(NZ+6),ID(NZ+12),MM,IT
      WRITE(LI,85)C(1601),EZ
85    FORMAT(10H MAXIMUM =,F8.2,12H,  MINIMUM =,F8.2/)
      WRITE(LI,72)SC,NV
      IF(JP.GT.0)GOTO 92
      WRITE(LI,86)
86    FORMAT(34H      HEIGHT   X/A     Y/B     Z/C/)
      K=1
      DO 91 J=1601,NP,4
      L=K/100
      M=MOD(K/10,10)
      N=MOD(K,10)
87    IF(L)88,88,89
88    L=M
      M=N
      N=-1
      GOTO 87
89    WRITE(LI,90)ID(L+20),ID(M+20),ID(N+20),C(J),C(J+1),C(J+2),C(J+3)
90    FORMAT(1X,1HQ,3A1,F7.0,3F8.3)
91    K=K+1
92    IF(KF)94,93,93
93    IL(2)=NP
      IL(3)=MM
      CALL XPLAN
94    MM=MM+1
C      REWIND NI
      IF(NI.EQ.LC)ILC=0
      IF(NI.EQ.LA)ILA=0
      IF(NI.EQ.LF)ILF=0
      IF(JF)97,97,41
95    IN(20)=-8
C      WRITE(LB,*)IT,(IN(I),I=1,1620),C   !!!!!!?????? manque JN...?
      DO 1020 I=1,40
1020  IIT(I)=IT(I)
      DO 1021 I=1,400
1021  JJN(I)=JN(I)
      DO 1022 I=1,1620
1022  IIN(I)=IN(I)
      DO 1023 I=1,4380
1023  CC(I)=C(I)
C96     REWIND NI
96    IF(NI.EQ.LC)ILC=0
      IF(NI.EQ.LF)ILF=0
      IF(NI.EQ.LA)ILA=0
97    RETURN
      END
C
      SUBROUTINE XPLAN
      DIMENSION IH(15)
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,JN(400),IT(40),
     *D(4380),IQ(3334),G(126),F(84),IL(30),IM(28),IN(1620),C(4380),
     *H(5764),A(4860),IB(1500),IC(1500),B(1500)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      DATA IH(1)/1H0/,IH(2)/1H1/,IH(3)/1H2/,IH(4)/1H3/,IH(5)/1H4/
      DATA IH(6)/1H5/,IH(7)/1H6/,IH(8)/1H7/,IH(9)/1H8/,IH(10)/1H9/
      DATA IH(11)/1H /,IH(12)/1H*/,IH(13)/1HX/,IH(14)/1HY/,IH(15)/1HZ/
C      READ(LB,*)IT,JN,(IN(I),I=1,1620),C
      DO 1000 I=1,40
1000  IT(I)=IIT(I)
      DO 1001 I=1,400
1001  JN(I)=JJN(I)
      DO 1002 I=1,1620
1002  IN(I)=IIN(I)
      DO 1003 I=1,4380
1003  C(I)=CC(I)
C
C EXPAND SYMMETRY OPERATORS
C
      NS=IN(1)
      NL=IN(18)*3
      L=INT(2.1-C(23))
      KP=1498
      W=1.
      IF(IABS(IN(14)).EQ.1)KP=0
      IF(IABS(IN(14)).EQ.6)KP=0
      IF(KP.NE.0)GOTO 1
      W=0.
      L=2
1     DO 2 I=4,12
2     F(I)=0.5
      DO 3 I=1,3
3     F(I)=0.
      IF(NL-12)6,4,10
4     DO 5 I=4,12,4
5     F(I)=0.
6     IF(NL-9)11,7,11
7     DO 8 I=4,9
8     F(I)=.6666667
      DO 9 I=5,7
9     F(I)=.3333333
      GOTO 11
10    K=IN(18)-1
      F(K)=0.
      NL=4
11    NY=0
      DO 14 I=61,NS,12
      M=I+11
      Q=1.
      DO 14 K=1,L
      DO 13 N=1,NL,3
      DO 12 J=I,M
      NY=NY+1
12    H(NY)=Q*C(J)
      H(NY-2)=H(NY-2)*W+F(N)
      H(NY-1)=H(NY-1)*W+F(N+1)
13    H(NY)=H(NY)*W+F(N+2)
14    Q=-1.
C
C ATOMS
C
      NM=0
      ASSIGN 16 TO NQ
      ASSIGN 16 TO NU
      IG=IN(6)
      MA=-5
      MI=-1
      ND=0
      NT=0
      JV=(IN(9)+500)/1000
      NN=1000*JV-IN(9)
      NP=IABS(NN)
      JV=MIN0(JV,3)
      IF(JV.LT.1)GOTO 15
      JD=MOD(JV,3)+1
      JA=MOD(JD,3)+1
      AA=SQRT(19.73921/C(JA+13))
      AD=-C(JA+1)*SIN(.0174533*C(JD+4))*C(JV+16)/C(JV+19)
      DD=C(JD+1)*SIN(.0174533*C(JA+4))
15    I=17
      K=IN(5)+1
      IF(NN)16,16,26
16    I=I+4
      IF(IG-I)26,17,17
17    MA=MA+6
      MI=MI+2
      A(MA)=0.
      A(MA+1)=C(K)
      A(MA+2)=C(K+1)
      A(MA+3)=C(K+2)
      J=NS+12+103*((IN(I+2)-12)/2)
      A(MA+5)=C(J)+0.25
      K=K+IN(I)
C
C BONDS
C
18    P=0.
      NA=ND
      XA=0.
      YA=0.
      ZA=0.
      IN(MI+1)=0
      DO 125 L=1,NY,12
      X=A(MA+1)*H(L)+A(MA+2)*H(L+1)+A(MA+3)*H(L+2)+H(L+9)
      Y=A(MA+1)*H(L+3)+A(MA+2)*H(L+4)+A(MA+3)*H(L+5)+H(L+10)
      Z=A(MA+1)*H(L+6)+A(MA+2)*H(L+7)+A(MA+3)*H(L+8)+H(L+11)
      NJ=2
      DO 25 J=1,MA,6
      IF(IN(NJ))25,19,19
19    U=A(J+1)-X
      V=A(J+2)-Y
      W=A(J+3)-Z
      U=U-AINT(U+SIGN(0.5,.000001+U))
      V=V-AINT(V+SIGN(0.5,.000001+V))
      W=W-AINT(W+SIGN(0.5,.000001+W))
      R=SQRT(U*U*C(8)+V*V*C(9)+W*W*C(10)+V*W*C(11)+U*W*C(12)+U*V*C(13))
      IF(A(J+5)+A(MA+5)-R)25,20,20
20    IF(0.5-R)24,21,21
21    IF(J-MA)23,22,22
22    P=P+1.
      XA=XA+U
      YA=YA+V
      ZA=ZA+W
      GOTO 25
23    A(MA+4)=R
      IN(MI+1)=-(J+5)/6
      GOTO NU,(16,27)
24    IB(NA+1)=(J+5)/3
      IC(NA+1)=(MA+5)/3
      B(NA+1)=R
      NA=MIN0(1+KP,NA+1)
25    NJ=NJ+2
  125 CONTINUE
      P=AMAX1(P,1.)
      A(MA+4)=1./P
      A(MA+1)=A(MA+1)-XA/P
      A(MA+2)=A(MA+2)-YA/P
      A(MA+3)=A(MA+3)-ZA/P
      IN(MI+1)=0
      ND=NA
      GOTO NQ,(16,30)
C
C PEAKS
C
26    ASSIGN 30 TO NQ
      ASSIGN 27 TO NU
      IG=0
      I=1597
      IF(NP.EQ.0)GOTO 31
27    I=I+4
      IF(IL(2)-I)31,28,28
28    IG=IG+1
      IF(4854-MA)31,29,29
29    MA=MA+6
      MI=MI+2
      IN(MI)=IG
      A(MA)=D(I)
      A(MA+1)=D(I+1)
      A(MA+2)=D(I+2)
      A(MA+3)=D(I+3)
      A(MA+5)=1.2+SIGN(0.3,D(I)-200.)
      GOTO 18
30    NT=NT+1
      IF(NT-NP)27,31,31
C
C ASSEMBLE MOLECULES
C
31    NA=0
      NM=0
32    NA=NA+1
      ASSIGN 32 TO NQ
      IF(ND-NA)51,33,33
33    I=IB(NA)
      J=IC(NA)
      IF(I-J)34,32,34
34    NB=NA
      IF(IN(I)+IN(J))35,35,37
35    NB=NB+1
      IF(ND-NB)32,36,36
36    IF((IB(NB)-I)*(IB(NB)-J)*(IC(NB)-J))35,40,35
37    IF(IN(I))43,43,38
38    IF(IN(J))39,39,47
39    N=3*J-4
      M=3*I-4
      IN(J)=IN(I)
      GOTO 44
40    IF(IABS(IB(NB)-I)+IABS(IC(NB)-J))35,35,41
41    IF(IB(NB)-IC(NB))42,35,42
42    NM=MIN0(NM+1,10)
      IN(J)=NM
      NB=NA
43    IN(I)=IN(J)
      N=3*I-4
      M=3*J-4
44    DO 45 L=1,NY,12
      X=A(N)*H(L)+A(N+1)*H(L+1)+A(N+2)*H(L+2)+H(L+9)
      Y=A(N)*H(L+3)+A(N+1)*H(L+4)+A(N+2)*H(L+5)+H(L+10)
      Z=A(N)*H(L+6)+A(N+1)*H(L+7)+A(N+2)*H(L+8)+H(L+11)
      U=A(M)-X
      V=A(M+1)-Y
      W=A(M+2)-Z
      U=U-AINT(U+SIGN(0.5,.000001+U))
      V=V-AINT(V+SIGN(0.5,.000001+V))
      W=W-AINT(W+SIGN(0.5,.000001+W))
      IF(A(N+4)+A(M+4)-SQRT(U*U*C(8)+V*V*C(9)+W*W*C(10)+V*W*C(11)+
     *U*W*C(12)+U*V*C(13)))45,45,46
45    CONTINUE
46    A(N)=A(M)-U
      A(N+1)=A(M+1)-V
      A(N+2)=A(M+2)-W
      ASSIGN 50 TO NQ
47    NB=NB+1
      IF(ND-NB)49,48,48
48    I=IB(NB)
      J=IC(NB)
      IF(IN(I)+IN(J))47,47,37
49    GOTO NQ,(50,32)
50    ASSIGN 32 TO NQ
      NB=NA
      GOTO 47
C
C ORIENTATION MATRICES
C
51    ZA=C(2)*COS(.0174533*C(6))
      YB=C(3)*SIN(.0174533*C(5))
      ZB=C(3)*COS(.0174533*C(5))
      YA=(C(2)*C(3)*COS(.0174533*C(7))-ZB*ZA)/YB
      XA=SQRT(C(2)*C(2)-ZA*ZA-YA*YA)
      ZC=C(4)
      L=17
      DO 52 K=1,178,3
      H(K)=99999.
      H(K+1)=-99999.
52    H(K+2)=.01
53    N=2
      NI=-2
      DO 60 I=1,MA,6
      M=0
      J=-2
      NI=NI+3
      C(NI)=XA*A(I+1)
      C(NI+1)=YA*A(I+1)+YB*A(I+2)
      C(NI+2)=ZA*A(I+1)+ZB*A(I+2)+ZC*A(I+3)
      K=IN(N)*18-L
      IF(K)60,60,55
54    H(K+5)=R
      R=1./SQRT(R)
      H(K)=X*R
      H(K+1)=Y*R
      H(K+2)=Z*R
55    M=M+2
      J=J+3
      IF(NI-J)60,60,56
56    IF(IN(N)-IN(M))55,57,55
57    X=C(J)-C(NI)
      Y=C(J+1)-C(NI+1)
      Z=C(J+2)-C(NI+2)
      IF(14-L)59,58,58
58    U=Y*H(K-4)-Z*H(K-5)
      V=Z*H(K-6)-X*H(K-4)
      Z=X*H(K-5)-Y*H(K-6)
      X=U
      Y=V
59    R=X*X+Y*Y+Z*Z
      IF(R-H(K+5))55,54,54
60    N=N+2
      L=L-6
      IF(8-L)53,61,61
61    NJ=NM*18
      DO 62 J=1,NJ,18
      H(J+3)=H(J+7)*H(J+2)-H(J+1)*H(J+8)
      H(J+4)=H(J)*H(J+8)-H(J+2)*H(J+6)
62    H(J+5)=H(J+1)*H(J+6)-H(J)*H(J+7)
C
C SCALE PLOTS
C
      I=1
      DO 65 J=1,MI,2
      IF(IN(J+1))65,65,63
63    L=IN(J+1)*18-17
      M=L+6
      DO 64 K=L,M,3
      X=C(I)*H(K)+C(I+1)*H(K+1)+C(I+2)*H(K+2)
      H(K+9)=AMIN1(X,H(K+9))
64    H(K+10)=AMAX1(X,H(K+10))
65    I=I+3
      Y=117./HA
      Z=114./HD
      DO 69 K=1,NJ,18
      H(K+11)=AMIN1(1.,Z/AMAX1(.1,H(K+10)-H(K+9)),Y/
     *AMAX1(.1,H(K+13)-H(K+12)))
      IF(Y-H(K+10)+H(K+9))68,66,66
66    I=K+2
      DO 67 J=K,I
      U=H(J)
      H(J)=H(J+3)
67    H(J+3)=-U
      H(K+9)=H(K+12)
      H(K+12)=-H(K+10)
68    H(K+16)=HD*H(K+11)
69    H(K+17)=HA*H(K+11)
C
C PRINT TABLES
C
      WRITE(LI,70)
70    FORMAT(//6X,
     *61HATOM HEIGHT   X/A     Y/B     Z/C   S.O.F. MOLECULE ELEVATION/)
71    FORMAT(1X,I4,3X,A4,6X,4F8.4,I5,F11.2)
72    FORMAT(1X,I4,3X,1HQ,I3,F6.0,4F8.4,I5,F11.2)
73    FORMAT(1X,I4,3X,A4,6X,3F8.4,4H  **,F6.3,5H FROM,I4)
74    FORMAT(1X,I4,3X,1HQ,I3,F6.0,3F8.4,4H  **,F6.3,5H FROM,I4)
      N=1
      I=-1
      NB=0
      DO 84 J=1,MA,6
      NB=NB+1
      NJ=J+1
      I=I+2
      L=IN(I+1)
      K=J+4
      IF(L)75,78,78
75    L=-L
      IF(A(J)-0.1)77,76,76
76    WRITE(LI,74)NB,IN(I),(A(M),M=J,K),L
      GOTO 84
77    WRITE(LI,73)NB,JN(NB),(A(M),M=NJ,K),L
      GOTO 84
78    A(J+5)=0.
      IF(L)80,80,79
79    M=18*L-17
      A(J+5)=(C(N)*H(M+6)+C(N+1)*H(M+7)+C(N+2)*H(M+8)-H(M+15))*H(M+11)
80    IF(A(J)-0.1)82,81,81
81    WRITE(LI,72)NB,IN(I),(A(NI),NI=J,K),L,A(J+5)
      GOTO 83
82    WRITE(LI,71)NB,JN(NB),(A(NI),NI=NJ,K),L,A(J+5)
83    IF(L.LT.1)GOTO 84
      IN(I)=INT((C(N)*H(M)+C(N+1)*H(M+1)+C(N+2)*H(M+2)-H(M+9))*H(M+16)+
     *1.01)*121+INT((C(N)*H(M+3)+C(N+1)*H(M+4)+C(N+2)*H(M+5)-H(M+12))*
     *H(M+17)+2.01)
84    N=N+3
      IF(KP.EQ.0)GOTO 110
85    FORMAT(//41H BONDS (INCLUDING SYMMETRY RELATED ATOMS)/)
      WRITE(LI,85)
      DO 86 I=1,ND
      IB(I)=IB(I)/2
86    IC(I)=IC(I)/2
87    FORMAT(7(I7,1H-,I3,F6.2)/)
      WRITE(LI,87)(IB(I),IC(I),B(I),I=1,ND)
C
C PLOT MOLECULES
C
88    FORMAT(9H1MOLECULE,I3,5H  FOR,40A1//7H MATRIX,9F8.4,10H   SCALE =,
     *F6.3,20H INCHES PER ANGSTROM//)
      M=121
      I=0
      N=-17
89    N=N+18
      I=I+1
      IF(I.GT.NM)GOTO 97
      NJ=N+8
      WRITE(LI,88)I,IT,(H(J),J=N,NJ),H(N+11)
      NJ=121
      DO 90 J=1,MI,2
90    IF(IN(J+1).EQ.I)NJ=MAX0(NJ,IN(J))
      NJ=NJ/121
      DO 96 K=1,NJ
      DO 91 J=1,M
91    IB(J)=IH(11)
      M=1
      DO 94 J=1,MI,2
      IF(IN(J+1).NE.I)GOTO 94
      IF(K.NE.(IN(J)/121))GOTO 94
      L=MOD(IN(J),121)
      NB=(J+1)/2
      NI=MOD(NB,10)+1
      M=MAX0(L+2,M)
      IF(IB(L+2).NE.IH(11))NI=12
      IB(L+2)=IH(NI)
      NI=NB/10
      IF(NI)94,94,92
92    NI=MOD(NI,10)+1
      IF(IB(L+1).NE.IH(11))NI=12
      IB(L+1)=IH(NI)
      NI=NB/100
      IF(NI)94,94,93
93    IF(IB(L).NE.IH(11))NI=11
      IB(L)=IH(NI+1)
94    CONTINUE
95    FORMAT(1X,121A1)
96    WRITE(LI,95)(IB(L),L=1,M)
      GOTO 89
C
C SCALE PROJECTION
C
97    IF(JV.EQ.0)GOTO 110
      Q=AA
      P=0.
      R=AMIN1(0.,AD)
      L=40
      ASSIGN 100 TO NU
      ASSIGN 102 TO NQ
98    J=-5
      NI=0
99    J=J+6
      IF(J.GT.MA)GOTO NQ,(102,104)
      NI=NI+2
      IF(IN(NI).LT.0)GOTO 99
      I=J+JA
      K=J+JD
      W=A(I)*AA
      U=A(I)*AD+A(K)*DD
      GOTO NU,(100,101)
100   Q=AMAX1(Q,W)
      P=AMIN1(P,W)
      R=AMIN1(R,U)
      GOTO 99
101   L=L+1
      IB(L+1400)=MOD(IN(NI),10)+1
      IC(L+1400)=INT(S*(W-P)+2.1)
      IC(L)=INT(T*(U-R)+2.1)
      GOTO 99
102   S=AMIN1(1.,Y/(Q-P))
      WRITE(LI,103)IH(JV+12),S
103   FORMAT(11H1VIEW DOWN ,A1,15H AXIS,  SCALE =,F6.3,
     *20H INCHES PER ANGSTROM//)
      T=S*HD
      S=S*HA
      ASSIGN 101 TO NU
      ASSIGN 104 TO NQ
      GOTO 98
C
C AXES
C
104   U=0.1
      W=0.
      V=0.
      DO 105 I=1,40
      IB(I+1400)=12
      IC(I+1400)=INT(S*(W*AA-P)+2.1)
      IC(I)=INT(T*(V*DD+W*AD-R)+2.1)
      IF(I.EQ.21)U=-0.1
      J=MOD((I-1)/10,2)
      IF(J.EQ.0)W=W+U
105   IF(J.EQ.1)V=V+U
      IB(1401)=JV+12
      IB(1411)=JA+12
      IB(1431)=JD+12
C
C PLOT PROJECTION
C
      NI=1
      DO 106 J=1,L
106   NI=MAX0(NI,IC(J))
      DO 109 I=1,NI
      DO 107 J=2,M
107   IB(J)=IH(11)
      M=1
      DO 108 J=1,L
      IF(IC(J).NE.I)GOTO 108
      K=IC(J+1400)
      M=MAX0(M,K)
      N=IB(J+1400)
      IB(K)=IH(N)
108   CONTINUE
109   WRITE(LI,95)(IB(K),K=1,M)
110   RETURN
      END
C
      SUBROUTINE XERR
      DIMENSION IL(5)
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,JN(400),
     +IT(40),IN(1620),C(4380),IG(5000),IK(5000),IP(20),F(84),G(84)
      COMMON/PC1/FF(10000,84),ILF,EE(10000,84),ILA,FC(10000,84),ILC
      COMMON/PC2/IIT(40),JJN(400),IIN(1620),CC(4380)
      DATA IL(1)/1HN/,IL(2)/1HV/,IL(3)/1HH/,IL(4)/1HK/,IL(5)/1HL/
C      READ(LB,*)IT,JN,IN,C
      DO 1000 IJ=1,40
1000  IT(IJ)=IIT(IJ)
      DO 1001 IJ=1,400
1001  JN(IJ)=JJN(IJ)
      DO 1002 IJ=1,1620
1002  IN(IJ)=IIN(IJ)
      DO 1003 IJ=1,4380
1003  C(IJ)=CC(IJ)
      KK=1
C
C NTAB IS 6 TIMES THE NUMBER OF REFLECTIONS PER PAGE IN THE FOFC TABLES.
C SINCE THERE ARE 5 REFLECTIONS PER LINE, NTAB MUST BE A MULTIPLE OF 30.
C NTAB MUST NOT BE GREATER THAN THE DIMENSIONS OF IG AND IK (WHICH MAY
C BE INCREASED IF NECESSARY).  THE VALUE NTAB=2880 IS SUITABLE FOR
C COMPRESSED OUTPUT ON EUROPEAN A4 PAPER USING AN HP-LASERJET PRINTER.
C
      NTAB=2880
C
C ERROR MESSAGES
C
      IF(IN(20))1,41,41
   1  NER=-IN(20)
   2  WRITE(LI,3)
   3  FORMAT(///9H ** ERROR/)
      GOTO(4,6,11,13,15,17,29,20,9,22,24,27,31,33,35,37,39),NER
   4  WRITE(LI,5)IN(1)
   5  FORMAT(12H UNSUITABLE ,A4,5H CARD)
      GOTO 129
   6  WRITE(LI,7)
   7  FORMAT(19H CRYSTAL INCOMPLETE)
      GOTO 129
   8  FORMAT(/26H MAXIMUM NUMBER ALLOWED IS,I6)
   9  WRITE(LI,10)
  10  FORMAT(/18H PROBLEM TOO LARGE)
      GOTO 129
  11  WRITE(LI,12)
  12  FORMAT(15H TOO MANY ATOMS)
  13  WRITE(LI,14)
  14  FORMAT(26H 2N(ISO)+N(ANIS) TOO LARGE)
      WRITE(LI,8)IN(1)
      GOTO 129
  15  WRITE(LI,16)IN(1)
  16  FORMAT(29H ILLEGAL CONSTRAINTS TO ATOM ,A4)
      GOTO 129
  17  WRITE(LI,18)
  18  FORMAT(25H CONDENSED DATA CORRUPTED)
      GOTO 129
  19  FORMAT(17H USE LARGER STORE)
  20  WRITE(LI,21)
  21  FORMAT(29H NOT ENOUGH STORE FOR FOURIER)
      GOTO 26
  22  WRITE(LI,23)IN(1)
  23  FORMAT(1X,A4,13H CARD MISSING)
      GOTO 129
  24  WRITE(LI,25)
  25  FORMAT(49H TOO MANY INDEPENDENT VARIABLES FOR LEAST-SQUARES)
      WRITE(LI,8)IN(1)
  26  WRITE(LI,19)
      GOTO 129
  27  WRITE(LI,28)
  28  FORMAT(28H SORTED F(OBS) DATA REQUIRED)
      GOTO 129
  29  WRITE(LI,30)
  30  FORMAT(29H ATOMS REQUIRED BUT NOT GIVEN)
      GOTO 129
  31  WRITE(LI,32)
  32  FORMAT(29H UNKNOWN ELEMENT ON SFAC CARD)
      GOTO 129
  33  WRITE(LI,34)
  34  FORMAT(20H BLOC IN RIGID GROUP)
      GOTO 129
  35  WRITE(LI,36)
  36  FORMAT(22H BAD DATA OR HKLF CARD)
      GOTO 129
  37  WRITE(LI,38)
  38  FORMAT(35H TOO MANY LAYERS (OR BAD AXIS CARD))
      GOTO 26
  39  WRITE(LI,40)
  40  FORMAT(15H NO F(OBS) DATA)
      GOTO 129
C
C FO/FC TABLES
C
  41  NT=IABS(IN(11))
      LS=IN(13)
      KP=1
      W=1.
      J=0
      IF(IN(11))42,65,43
  42  W=10.
  43  I=-5
C      READ(LA,*)F
      ILA=ILA+1
      DO 210 IJ=1,84
210   F(IJ)=EE(ILA,IJ)
C      READ(LF,*)G
      ILF=ILF+1
      DO 171 IJ=1,84
171   G(IJ)=FF(ILF,IJ)
  44  I=I+6
      IF(LV-I)43,45,45
  45  ASSIGN 63 TO NQ
      IF(ABS(F(I))-.8)47,46,46
  46  ASSIGN 62 TO NQ
      CALL HKL(F(I),X,Y,Z)
      IF(NTAB.GT.J)GOTO 62
  47  K=1
      NJ=(J-1)/30
      NK=NJ*6
      L=-5
      NJ=(MOD(J+29,30)+1)*(NJ+1)
  48  L=L+6
      NI=NK
      M=L
  49  IF(J-M)48,50,50
  50    DO 51 N=1,6
        IK(K)=IG(M)
        M=M+1
  51    K=K+1
      M=M+NI
      IF(M-NJ)53,52,52
  52  NI=NK-6
  53  IF(J-K)54,49,49
  54    DO 60 K=1,NT
        WRITE(LI,55)IT,KP
  55    FORMAT(49H1  OBSERVED AND CALCULATED STRUCTURE FACTORS FOR ,
     +  40A1,32X,4HPAGE,I3/)
        IF(IN(11))56,58,58
  56    WRITE(LI,57)
  57    FORMAT(5('   H  K  L 10FO 10FC 10S  ')/)
        GOTO 60
  58    WRITE(LI,59)
  59    FORMAT(5('   H  K  L   FO   FC   S  ')/)
  60    WRITE(LI,61)(IK(NP),NP=1,J)
  61  FORMAT(5(I4,2I3,2I5,I4,2X))
      KP=KP+1
      J=0
      GOTO NQ,(62,63)
  62  IG(J+1)=X
      IG(J+2)=Y
      IG(J+3)=Z
      IG(J+4)=INT(F(I+1)*W+0.5)
      IG(J+5)=INT(F(I+4)*W+SIGN(0.5,F(I+4)+1.E-5))
      J=J+6
      IG(J)=INT(SQRT(ABS(G(I+2)))*F(I+1)*W/G(I+1)+0.5)
      IF(G(I+3).GT.C(46))IG(J)=-IG(J)
      IF(C(23).LT.0.1)GOTO 44
      IG(J-1)=INT(W*SQRT(F(I+4)*F(I+4)+F(I+5)*F(I+5))+0.5)
      GOTO 44
C
C F(OBS) CARDS ETC.
C
C  63  REWIND LA
  63  ILA=0
      WRITE(LI,64)
  64  FORMAT(1H1)
  65  LQ=LF
      NJ=MIN0(IABS(IN(10))+1,7)
      NP=0
      JK=0
      NER=12
        DO 66 I=1000,1600
  66    C(I)=0.
      GOTO(129,72,69,77,77,67,76),NJ
  67  WRITE(LI,73)IT
      WRITE(LI,68)
  68  FORMAT(51H   H   K   L     FO      FC      A       B      PHI,
     +19H    DEL(F)  SIG*(F)/)
      GOTO 76
  69  WRITE(LP,70)IT
  70  FORMAT(/23H    CONDENSED DATA FOR ,40A1)
C      READ(LF,*)F
C      REWIND LF
      ILF=ILF+1
      DO 141 IJ=1,84
141   F(IJ)=FF(ILF,IJ)
      ILF=0
      NN=MIN0(INT(F(1)-1.1),0)
      WRITE(LP,71)NN
  71  FORMAT(/33HHKLF -1 1  1 0 0  0 1 0  0 0 1  1,I8)
      GOTO 77
  72  WRITE(LI,73)IT
  73  FORMAT(1H1,40A1//)
      WRITE(LI,74)
  74  FORMAT(32H DEVIATIONS GREATER THAN 2 SIGMA/)
      WRITE(LI,75)
      SC=10000./C(26)
  75  FORMAT(37H   H   K   L     FO      FC   D/SIGMA/)
  76  LQ=LA
C  77  READ(LQ,*)F
77    IF(LQ.EQ.LF)GO TO 132
C      READ(LQ,*)F
      ILA=ILA+1
      DO 211 IJ=1,84
211   F(IJ)=EE(ILA,IJ)
      GO TO 133
132   ILF=ILF+1
      DO 142 IJ=1,84
142   F(IJ)=FF(ILF,IJ)
133   I=-5
  78  I=I+6
      IF(LV-I)77,79,79
  79  IF(ABS(F(I))-.8)111,80,80
  80  IF(NJ.EQ.3)GOTO 81
      IF(C(46)-F(I+3))78,81,81
  81  CALL HKL(F(I),C(2),C(3),C(4))
      Q=SQRT(126.6515*F(I+3))*C(1)
      NH=C(2)
      NK=C(3)
      NL=C(4)
      S=F(I+4)*F(I+4)+F(I+5)*F(I+5)
      U=SQRT(S)+1.E-8
      V=F(I+1)-U
      T=F(I+2)*V*V
      SF=ABS(1.E-5/F(I+2))
      N=I+5
      IF(NJ.EQ.7)GOTO 83
      N=I+2
      F(I+2)=SQRT(F(I+2))
      GOTO(78,85,90,83,82,84),NJ
  82  N=I+1
      F(I+1)=AMOD(F(I+4),10.)
  83  M=I+1
      WRITE(LP,89)NH,NK,NL,(F(J),J=M,N)
      GOTO 78
  84  S=1./F(I+2)
      T=AMOD(720.+ATAN2(F(I+5),F(I+4))*57.29578,360.)
      WRITE(LI,89)NH,NK,NL,F(I+1),U,F(I+4),F(I+5),T,V,S
      GOTO 78
  85  C(1309)=C(1309)+T
      C(1009)=C(1009)+1.
      J=INT(AMOD(400.1+4.*C(4),8.)+AMOD(400.1+2.*C(3),4.)+
     +AMOD(400.1+C(2),2.))
      C(J+1301)=C(J+1301)+T
      C(J+1001)=C(J+1001)+1.
      N=1041
        DO 86 K=2,4
        J=MIN0(INT(ABS(C(K))+0.1),14)
        L=J+N
        C(L)=C(L)+1.
        C(L+300)=C(L+300)+T
  86    N=N+15
        DO 87 K=1101,1201,100
        J=K+INT(Q)
        C(J+300)=C(J+300)+T
        C(J)=C(J)+1.
  87    Q=SQRT(ABS(SC*F(I+1)))-0.01
      IF(T-4.*C(29))78,78,88
  88  T=SQRT(T/C(29))
      WRITE(LI,89)NH,NK,NL,F(I+1),U,T
  89  FORMAT(3I4,8F8.2)
      GOTO 78
C
C CONDENSED DATA
C
  90  J=NH+100*(NK+100*NL)-NN
      IF(J)2,2,96
  91  NN=NN+99900-J
      J=J-99900
      K=999
      ASSIGN 96 TO NQ
  92  NP=NP+1
      IP(NP)=K
      JK=MOD(JK+K*KK,10000)
      IF(NP-20)95,93,93
  93  WRITE(LP,94)IP
      KK=MOD(KK,99)+1
  94  FORMAT(20I4)
      NP=0
  95  GOTO NQ,(78,96,99,102,107)
  96  NN=NN+J
      IF(J-100000)97,97,91
  97  IF(J-1000)100,100,98
  98  K=(J-1)/100
      ASSIGN 99 TO NQ
      GOTO 92
  99  J=J-(100*K)
 100  IF(J-10)103,101,101
 101  K=1-J
      ASSIGN 102 TO NQ
      GOTO 92
 102  J=J+K
 103  K=1000
      X=AMIN1(SF,9.89)
 104  K=K-100
      X=X*10.
      IF(K)105,106,105
 105  IF(X-9.9)104,106,106
 106  K=K+INT(X+0.5)+(1000*J)
      ASSIGN 107 TO NQ
      GOTO 92
 107  K=10000
      X=AMIN1(ABS(F(I+1)*1.E-6),99.89)
 108  K=K-1000
      X=X*10.
      IF(K-1000)109,110,109
 109  IF(X-99.9)108,110,110
 110  K=K+INT(X+0.5)
      ASSIGN 78 TO NQ
      GOTO 92
C
C END OF DATA
C
C 111  REWIND LQ
 111  IF(LQ.EQ.LF)ILF=0
      IF(LQ.EQ.LA)ILA=0
      IF(NJ.NE.3)GOTO 113
      NP=NP+1
      LS=0
      IP(NP)=0
      IF(20.GT.NP)GOTO 112
      WRITE(LP,94)IP
      NP=0
 112  NP=NP+1
      IP(NP)=JK
      WRITE(LP,94)(IP(I),I=1,NP)
 113  IF(LS.GT.-998)WRITE(LP,114)
 114  FORMAT(/3HEND//)
      IF(NJ.NE.2)GOTO 129
C
C ANALYSIS OF VARIANCE
C
      WRITE(LI,115)IT
 115  FORMAT(25H1ANALYSIS OF VARIANCE FOR ,40A1///19X,
     +59HGGG    UGG    GUG    UUG    GGU    UGU    GUU    UUU    ALL)
 116  FORMAT(/8X,A1,6X,15I7)
 117  FORMAT(///19H SIN THETA     0.00,10(2H -,F5.2))
 118  FORMAT(///19H SQRT(F/FMAX)  0.00,10(2H -,F5.2))
 119  FORMAT(///9X,4HABS(,A1,8H)      0,13I7,4X,4HREST)
        DO 120 I=1,13
 120    IG(I)=I
      X=0.1*C(1009)
        DO 123 L=10,20,10
        M=L-10
        W=0.001
        N=(L*10)+1000
        Y=-0.5
        S=0.
 121    M=M+1
        Y=Y+X
        IF(L-M)123,122,122
 122    W=W+0.01
        N=N+1
        S=S+C(N)
        C(M+1020)=C(M+1020)+C(N)
        C(M+1320)=C(M+1320)+C(N+300)
        C(M+1400)=W
        IF(Y-S)121,122,122
 123    CONTINUE
      M=9
      I=1001
        DO 128 NL=1,6
          DO 124 L=1,M
          X=100.*SQRT(C(I+300)*C(27)/AMAX1(C(I),1.))+0.5
          IP(L)=X
          IK(L)=C(I)
 124      I=I+1
        WRITE(LI,116)IL(1),(IK(L),L=1,M)
        WRITE(LI,116)IL(2),(IP(L),L=1,M)
        GOTO(125,126,127,127,127,128),NL
 125    WRITE(LI,117)(C(L),L=1401,1410)
        I=1021
        M=10
        GOTO 128
 126    WRITE(LI,118)(C(L),L=1411,1420)
        GOTO 128
 127    M=15
        WRITE(LI,119)IL(NL),(IG(L),L=1,13)
 128    CONTINUE
 129  RETURN
      END
